package dbc.r15.sample.b4xxntjr;

public class AccWorkAreaWrapper {
	private final int[] ACC_BUFFER = {0, 95};
	private final int[] ACC_ACCOUNT_ID = {0, 9};
	private final int[] ACC_BRANCH_ID = {9, 9};  
	private final int[] ACC_ACCOUNT_BAL = {18, 5}; // This is signed packed data
	private final int[] ACC_ADDDATE = {23, 4};
	private final int[] ACC_VERDATE = {27, 4};
	private final int[] ACC_FILLER = {31, 64};
	 
	// Variable to hold the binary data in the container 
	 
	private byte[] aData;
	 
	 /* Set the binary data of container */
	public void setByteArray(byte[] data) { aData = data;}
	 
	/* Get the binary data of the container */
	public byte[] getByteArray() {return aData;}
	 
	public void setAccountId(String newValue) {setNewValue(newValue, ACC_ACCOUNT_ID[0], ACC_ACCOUNT_ID[1]);
	}
	public String getAccountId() {return new String(aData, ACC_ACCOUNT_ID[0], ACC_ACCOUNT_ID[1]);
	}
	public void setBranchId(String newValue) {setNewValue(newValue, ACC_BRANCH_ID[0], ACC_BRANCH_ID[1]);
	}
	public String getBranchId() {return new String(aData, ACC_BRANCH_ID[0], ACC_BRANCH_ID[1]);
	}
	public void setAccountBal(String newValue) {setNewValue(newValue, ACC_ACCOUNT_BAL[0], ACC_ACCOUNT_BAL[1]);
	}
	public byte[] getAmtByteArray(){
		String s;
		s = new String(aData, ACC_ACCOUNT_BAL[0], ACC_ACCOUNT_BAL[1]);
		return s.getBytes();
		}
	public String getAccountBal() {return new String(aData, ACC_ACCOUNT_BAL[0], ACC_ACCOUNT_BAL[1]);
	}
	public void setAddDate(String newValue) {setNewValue(newValue, ACC_ADDDATE[0], ACC_ADDDATE[1]);
	}
	public String getAddDate() {return new String(aData, ACC_ADDDATE[0], ACC_ADDDATE[1]);
	}
	public void setVerDate(String newValue) {setNewValue(newValue, ACC_VERDATE[0], ACC_VERDATE[1]);
	}
	public String getVerDate() {return new String(aData, ACC_VERDATE[0], ACC_VERDATE[1]);
	}
	 
	/* Inserts a value into the main byte[] and pads with spaces if necessary.
	 * Note: values will be left justified
	 */
	private void setNewValue(String newValue, int index, int length) {
		/* 1. create a new byte array to hold the string called tData for temporary data
		 * 2. copy the new tData byte array to the cData byte array one byte at a time
		 * 3. pad the cData with spaces up to the length passed in on the call 
		 */
		byte tData[] = newValue.getBytes();		// .step 1.
		int tDatalen = tData.length;
		int cDatalen = aData.length;
		int i = 0;
		while ( i < length && index < cDatalen)
		{
			if ( i < tDatalen )
				aData[index++] = tData[i];
			else
				aData[index++] = 0x40;			
			i++;
		}
		

	}
	

}



