package dbc.r15.sample.b4xxntjr;	
 
import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.io.PrintWriter;
import java.nio.ByteBuffer;
import java.nio.ShortBuffer;
import java.util.*;
import java.text.*;

import com.ibm.cics.server.CCSIDErrorException;
import com.ibm.cics.server.Channel;
import com.ibm.cics.server.ChannelErrorException;
import com.ibm.cics.server.CicsException;
import com.ibm.cics.server.CodePageErrorException;
import com.ibm.cics.server.CommAreaHolder;
import com.ibm.cics.server.Container;
import com.ibm.cics.server.ContainerErrorException;
import com.ibm.cics.server.EndOfDataException;
import com.ibm.cics.server.InvalidProgramIdException;
import com.ibm.cics.server.InvalidRequestException;
import com.ibm.cics.server.InvalidSystemIdException;
import com.ibm.cics.server.LengthErrorException;
import com.ibm.cics.server.NotAuthorisedException;
import com.ibm.cics.server.Program;
import com.ibm.cics.server.RetrieveBits;
import com.ibm.cics.server.RetrievedDataHolder;
import com.ibm.cics.server.RolledBackException;
import com.ibm.cics.server.TDQ;
import com.ibm.cics.server.Task;
import com.ibm.cics.server.TerminalException;
import com.ibm.cics.server.TerminalPrincipalFacility;
import com.ibm.jzos.*;
import com.ibm.jzos.fields.PackedDecimalAsIntField;


public class B4XXNTJR {
	static String AccountElement = "SQLEL           ";
	static String HistoryElement = "SQLEL           ";
		// User Id Block container name.
	static String userIdBlock	  = "      QA-NTJR V1 02/17/2013     ";  
		// The five container names and the channel name
	static String userIdCont      = "UsrInfoContainer";    // cont1 .    
	static String rqstCont        = "RqstContainer   ";    // cont2     
	static String workCont        = "WorkContainer   ";    // cont3     
	static String elmtLstCont     = "ElmtLstContainer";    // cont4     
	static String rqaCont         = "RQAContainer    ";    // cont5
	static String testChannelName = "TestChannelBRAPR";    // chanOne
	
	public static void main(CommAreaHolder CAH) {
	//byte MyCommArea[] = CAH.value;  // ** TEMP CODE FOR TESTING **    //this out
	// Instantiate the wrapper class for account, history and various Qline classes
	CommareaWrapper caW = new CommareaWrapper();
	AccRqstAreaWrapper aRAW = new AccRqstAreaWrapper(); 
	AccWorkAreaWrapper aWAW = new AccWorkAreaWrapper(); 
	HstRqstAreaWrapper hRAW = new HstRqstAreaWrapper(); 
	HstWorkAreaWrapper hWAW = new HstWorkAreaWrapper(); 
	AQlineWrapper aQLW = new AQlineWrapper();
	BQlineWrapper bQLW = new BQlineWrapper();
	CQlineWrapper cQLW = new CQlineWrapper();
	DQlineWrapper dQLW = new DQlineWrapper();
	EQlineWrapper eQLW = new EQlineWrapper();
	PackedDecimalAsIntField pd = new PackedDecimalAsIntField(0, 9, true);
	int rowCounter = 0;
	int aBalance = 0, totHbal = 0;
	// define Account request Area byte array		                            
		byte ra[] = new byte [256];
		for (int j = 0; j < 256; j++) {
			ra[j] = (byte)0x00;
		}
	// define Account request Area byte array		                            
		byte awa[] = new byte [95];
		for (int j = 0; j < 95; j++) {
			awa[j] = (byte)0x00;
		}
		// define History Work Area byte array		                            
		byte hwa[] = new byte [55];
		for (int j = 0; j < 55; j++) {
			hwa[j] = (byte)0x00;
		}
		// define History Work Area byte array		                            
		byte tdq[] = new byte [132];
		for (int j = 0; j < 132; j++) {
			tdq[j] = (byte)0x40;	 
		}		 
		// Create the TDQ object
		TDQ Q = new TDQ();
		Q.setName("B400");  
		// Date and time formatting
		String ti;
		Calendar c = Calendar.getInstance();
		DateFormat formatter1 = new SimpleDateFormat("HH:mm:ss");
		ti = formatter1.format(c.getTime());
		// get access to task    
		Task t = null;
		int tn = 0;
		PrintWriter prw = null;
		try {
			t = Task.getTask();
			tn = t.getTaskNumber();
				prw = t.out;
				//t.out.println("Entering Program B4XXNTJR.main(1)");
//this out		caW.setByteArray(MyCommArea);		                   //this out
				//prw.println("Entering program B4XXNTJR with COMMAREA : " + caW.getBuffer());
				//t.out.println("Entering Program B4XXNTJR.main(2)");
//*				if (t != null) return;
				RetrievedDataHolder rdh = new RetrievedDataHolder();	//this in
				BitSet whatToRetrieve = new BitSet();					//this in
				whatToRetrieve.set(RetrieveBits.DATA);					//this in
				try {													//this in
					t.retrieve(whatToRetrieve, rdh);					//this in
					System.out.println("Retrieved DATA :" + new String(rdh.value.data)); //this in
					} catch (EndOfDataException e) {					//this
						System.err.append("No data to retrieve. Did you start the transaction from a terminal ?");
						return;											//this in	
					} catch (CicsException e) {							//this in
					e.printStackTrace();								//this in
						return;											//this in
					}													//this in
					finally { }											//this in
// Create a Channel to pass to the "bridge" program
				Channel chanOne = t.createChannel(testChannelName);

//Create 4 Containers to hold the "User-Id","request area", "work area", "element list"  
				Container cont1 = chanOne.createContainer(userIdCont); 
				Container cont2 = chanOne.createContainer(rqstCont);
				Container cont3 = chanOne.createContainer(workCont);
				Container cont4 = chanOne.createContainer(elmtLstCont);
				//write User_ID block to container
				cont1.put(userIdBlock); 
				// Initialize the Commarea Wrapper						
				caW.setByteArray(rdh.value.data);						//this in
//*				caW.setByteArray(MyCommArea);
// Get the first Account record
				// Initialize the Account Request Area
				aRAW.setByteArray(ra);		   	   	 // Initialize request area wrapper
				aRAW.setCommand("REDKX");		   	 // Command
				aRAW.setTableName("ACC");          	 // Table name
				aRAW.setKeyName("SQ004");          	 // Key name
				//urs = Short.valueOf(caW.getDbid());  // DBID
				aRAW.setDbid(Short.valueOf(caW.getDbid()));  // combined with above line
				aRAW.setKeyBid(caW.getBid());	   	 // Request Key BID
				aRAW.setKeyAid(caW.getAid());	   	 // Request Key Aid
		// write Account Request Area to container
				cont2.put(aRAW.getByteArray());
		// Initialize The Account Work Area
				aWAW.setByteArray(awa); 
		// write Account Work Area to container
				cont3.put(aWAW.getByteArray());
		// Write Account Element List to container
				cont4.put(AccountElement);
		// Create the Program object and set the program name
				Program p = new Program();
				p.setName("DCBRAPR");
// 1st LINK to the "bridge" with the channel to get Account info
				p.link(chanOne);
		// Account request container read
				Container rspRequestCont = chanOne.getContainer(rqstCont);
				byte[] rspAccRequestData = rspRequestCont.get();
		// move the data to cData byte array in Account Request wrapper
				aRAW.setByteArray(rspAccRequestData);
		// read in Account Work container
				Container rspWorkCont = chanOne.getContainer(workCont);
				byte[] rspAccWorkData = rspWorkCont.get();
		// move the data to cData byte array in Account Work wrapper
				aWAW.setByteArray(rspAccWorkData);
				//		prw.println("return Code from  : aRAW.getReturnCode() : " + aRAW.getReturnCode());
				
				if ( aRAW.getReturnCode().equals("14") ) { 
					prw.println("No records found OR we are at the end of file");
					exhibiT0700 (prw, Q, rowCounter, aBalance, totHbal, tn, caW, aQLW, eQLW);
					return;  //  GOTO 0700-EXHIBIT
				}  // YOU ARE HERE  YOU ARE HERE  YOU ARE HERE
				else
				if ( !aRAW.getReturnCode().equals("  ") ){ // *** TESTED*** 
					prw.println("make sure the connection to MUF is established");
		 // Move QLineC and write it to transient Q.
					for (int j = 0; j < 132; j++) {
						tdq[j] = (byte)0x40;}	 
					cQLW.setByteArray(tdq);									// l#1
					cQLW.setQlineC1(userIdBlock);							// l#2
					cQLW.setQlineC2(aWAW.getAccountId());					// l#3
					cQLW.setQlineC3(aWAW.getBranchId());					// l#4
					/*   This is packed                                        l#5 */
					cQLW.setQlineC4(String.valueOf(pd.getInt(aWAW.getAmtByteArray())));
					cQLW.setQlineC5(aWAW.getAddDate());						// l#6
					cQLW.setQlineC6(aWAW.getVerDate());						// l#7
					cQLW.setQlineC7(AccountElement);						// l#8
					writeTDQ (prw, Q, cQLW.getByteArray());        			
		     // Move QLineB and write it to TDQ.
					for (int j = 0; j < 132; j++) {
						tdq[j] = (byte)0x40;}	 
					bQLW.setByteArray(tdq);									// l#1
					bQLW.setQlineB1(aRAW.getCommand());						// l#2
					bQLW.setQlineB2(aRAW.getTableName());					// l#3
					bQLW.setQlineB3(aRAW.getKeyName());						// l#4
					bQLW.setQlineB4(aRAW.getReturnCode());					// l#5
					bQLW.setQlineB5(aRAW.getiReturnCode());					// l#6
					 
					byte [] arr = aRAW.getDbid().getBytes();				// DBID
					ByteBuffer bb = ByteBuffer.wrap(arr);
					ShortBuffer sb = bb.asShortBuffer();
					short s1 = sb.get();
					bQLW.setQlineB6(Short.toString(s1));  
					 
					arr = aRAW.getTblid().getBytes();						// TBLID
					bb = ByteBuffer.wrap(arr);
					sb = bb.asShortBuffer();
					s1 = sb.get();
					bQLW.setQlineB7(Short.toString(s1));  
					
					bQLW.setQlineB8(aRAW.getRecid());						// l#9
					bQLW.setQlineB9A(aRAW.getKeyBid());						// l#10
					bQLW.setQlineB9B(aRAW.getKeyAid());						// l#11
					writeTDQ (prw, Q, bQLW.getByteArray());  
		      // Move QLineD and write it to TDQ.
					for (int j = 0; j < 132; j++) {
						tdq[j] = (byte)0x40;}	 
					dQLW.setByteArray(tdq);									// l#1
					dQLW.setQlineD1("*** ERROR TRAN# ");					// L#2	
					dQLW.setQlineD2(caW.getTrancount());					// l#3
					dQLW.setQlineD11(" AID/BID= ");							// l#4
					dQLW.setQlineD3(caW.getAid());							// l#5
					dQLW.setQlineD4(caW.getBid());							// l#6
					dQLW.setQlineD5(caW.getDbid());							// l#7
					dQLW.setQlineD6(aRAW.getReturnCode());					// l#8
					dQLW.setQlineD7(" TAS# ");								// l#9
					dQLW.setQlineD8(Integer.toString(tn)); 					// l#10  
					dQLW.setQlineD9(" TIME ");								// l#11
					dQLW.setQlineD10(ti);									// l#12
					writeTDQ (prw, Q, dQLW.getByteArray());  
					return; //  GOTO 999-END.
				}
// Get the first History record
		// Initialize the History Request Area
				t.out.println("      got to LOCATION - 01               ");  
				hRAW.setByteArray(ra);		   
				hRAW.setCommand("REDKG");		   // Command
				hRAW.setTableName("HST");          // Table name
				hRAW.setKeyName("SQ005");          // Key name
				//urs = Short.valueOf(caW.getDbid());  // DBID
				hRAW.setDbid(Short.valueOf(caW.getDbid())); // combined with above line
				hRAW.setKeyBid(caW.getBid());	   // Request Key BID
				hRAW.setKeyAid(caW.getAid());	   // Request Key Aid
				hRAW.setTran(" ");                 // Request Tran 
				hRAW.setKey(" ");	               // Request Key
		// Write History Request Area to container
				cont2.put(hRAW.getByteArray());
		// Initialize The History Work Area
				hWAW.setByteArray(hwa); 
		// Write History Work Area to container
				cont3.put(hWAW.getByteArray());
		// Write History Element List to container
				cont4.put(HistoryElement);
			 
// 2nd LINK to the "bridge" with the channel to get History info
				p.link(chanOne);
				t.out.println("      got to LOCATION - 02               ");  
		// History request container read
				rspRequestCont = chanOne.getContainer(rqstCont);
				byte[] rspHstRequestArea = rspRequestCont.get();
		// Move the data to cData byte array in History Request wrapper
				hRAW.setByteArray(rspHstRequestArea);
		// History Work container read
				rspWorkCont = chanOne.getContainer(workCont);
				byte[] rspHstWorkArea = rspWorkCont.get();
		// Move the data to cData byte array in Account Request wrapper
				hWAW.setByteArray(rspHstWorkArea);
				
				if ( hRAW.getReturnCode().equals("14") ) {
					t.out.println("No records found OR we are at the end of file");  
					exhibiT0700 (prw, Q, rowCounter, aBalance, totHbal, tn, caW, aQLW, eQLW);
					return; //  GOTO 0700-EXHIBIT 
				}
				else
				if ( !hRAW.getReturnCode().equals("  ") ) {
				prw.println("make sure the connection to MUF is established");
				 //
				 // Move QLineC and write it to TDQ.
				for (int j = 0; j < 132; j++) {
					tdq[j] = (byte)0x40;}	 
				cQLW.setByteArray(tdq);									// l#1
				cQLW.setQlineC1(userIdBlock);							// l#2
				cQLW.setQlineC2(hWAW.getAccountId());					// l#3
				cQLW.setQlineC3(hWAW.getBranchId());					// l#4
				/* this is packed  										   l#5 */
				cQLW.setQlineC4(String.valueOf(pd.getInt(hWAW.getAmtByteArray())));
				cQLW.setQlineC5(hWAW.getAddDate());						// l#6
				cQLW.setQlineC6(hWAW.getVerDate());						// l#7
				cQLW.setQlineC7(hWAW.getTranNum());						// l#8
				cQLW.setQlineC8(hWAW.gettellerId());					// l#9
				cQLW.setQlineC9(HistoryElement);						// l#10
				writeTDQ (prw, Q, cQLW.getByteArray());       
				// Move QLineB and write it to TDQ.
				for (int j = 0; j < 132; j++) {
					tdq[j] = (byte)0x40;}	 
				bQLW.setByteArray(tdq);									// l#1
				bQLW.setQlineB1(hRAW.getCommand());						// l#2
				bQLW.setQlineB2(hRAW.getTableName());					// l#3
				bQLW.setQlineB3(hRAW.getKeyName());						// l#4
				bQLW.setQlineB4(hRAW.getReturnCode());					// l#5
				bQLW.setQlineB5(hRAW.getiReturnCode());					// l#6
				 
				byte [] arr = hRAW.getDbid().getBytes();				// DBID
				ByteBuffer bb = ByteBuffer.wrap(arr);
				ShortBuffer sb = bb.asShortBuffer();
				short s1 = sb.get();
				bQLW.setQlineB6(Short.toString(s1));  
				 
				arr = hRAW.getTblid().getBytes();						// TBLID
				bb = ByteBuffer.wrap(arr);
				sb = bb.asShortBuffer();
				s1 = sb.get();
				bQLW.setQlineB7(Short.toString(s1));  
				 
				bQLW.setQlineB8(hRAW.getRecid());						// l#9
				bQLW.setQlineB9A(hRAW.getKeyBid());						// l#10
				bQLW.setQlineB9B(hRAW.getKeyAid());						// l#11
				bQLW.setQlineB9C(hRAW.getTran());						// l#12
				writeTDQ (prw, Q, bQLW.getByteArray());  
				 // Move Request Key from History WA, write it to TDQ.  
				dQLW.setBuffer(hRAW.getKey());							// l#1
				writeTDQ (prw, Q, dQLW.getByteArray());  
				 // Move QLineD and write it to TDQ.
				for (int j = 0; j < 132; j++) {
					tdq[j] = (byte)0x40;}	 
				dQLW.setByteArray(tdq);									// l#1
				dQLW.setQlineD1("*** ERROR TRAN# ");					// L#2	
				dQLW.setQlineD2(caW.getTrancount());					// l#3
				dQLW.setQlineD11(" AID/BID= ");							// l#4
				dQLW.setQlineD3(caW.getAid());							// l#5
				dQLW.setQlineD4(caW.getBid());							// l#6
				dQLW.setQlineD5(caW.getDbid());							// l#7
				dQLW.setQlineD6(aRAW.getReturnCode());					// l#8
				dQLW.setQlineD7(" TAS# ");								// l#9
				dQLW.setQlineD8(Integer.toString(tn)); 					// l#10  
				dQLW.setQlineD9("  TIME ");								// l#11
				dQLW.setQlineD10(ti);									// l#12
				writeTDQ (prw, Q, dQLW.getByteArray());  
				return; //  GOTO 999-END.
				}
				if (!hRAW.getKeyBid().equals(caW.getBid())) { 
					t.out.println("      got to LOCATION - 03               ");  
				prw.println("Branches not equal"); 
					exhibiT0700 (prw, Q, rowCounter, aBalance, totHbal, tn, caW, aQLW, eQLW);
					return; //  GOTO 0700-EXHIBIT 
				}
		
				if (!hRAW.getKeyAid().equals(caW.getAid()))	{
					t.out.println("      got to LOCATION - 04               ");  
				prw.println("Accounts not equal");
				exhibiT0700 (prw, Q, rowCounter, aBalance, totHbal, tn, caW, aQLW, eQLW);
				return; //  GOTO 0700-EXHIBIT 
				}
			  // COMPUTE ABALANCE = ACC-ACCOUNT-BAL + 0
				aBalance = pd.getInt(aWAW.getAmtByteArray());  
			//	prw.println(" pd.getInt(aWAW.getAmtByteArray()) : " + pd.getInt(aWAW.getAmtByteArray()));
			  // COMPUTE TOT-HBAL = HST-AMOUNT +0 
				totHbal = pd.getInt(hWAW.getAmtByteArray());
			//	prw.println(" pd.getInt(hWAW.getAmtByteArray()) : " + pd.getInt(hWAW.getAmtByteArray()));
			  // up the ROW counter
				rowCounter++;
// TOP OF LOOP
// TOP OF LOOP
// TOP OF LOOP
			
			while (( hRAW.getReturnCode().equals("  ") ) &&
					(hWAW.getBranchId().equals(caW.getBid())) &&
					(hWAW.getAccountId().equals(caW.getAid()))) { // open loop bracket
		//		prw.println("TOP OF THE LOOP1   LINE1");
		//		prw.println(" hWAW.getAccountId() : " + hWAW.getAccountId());
		//		prw.println(" caW.getAid() : "+ caW.getAid());
		//		prw.println(" hWAW.getBranchId() : " + hWAW.getBranchId());
		//		prw.println(" caW.getBid() : "+ caW.getBid());
		//		prw.println("TOP OF THE LOOP1   LINE2");
			// Initialize the History Request Area; you may not need to do that
			//	hRAW.setByteArray(ra);		   
				hRAW.setCommand("REDNX");		   // Command
			//	hRAW.setTableName("HST");          // Table name
			//	hRAW.setKeyName("SQ005");          // Key name
			//	hRAW.setDbid(caW.getDbid());       // DBID
			//	hRAW.setKeyBid(caW.getBid());	   // Request Key BID
			//	hRAW.setKeyAid(caW.getAid());	   // Request Key Aid
			// Write History Request Area to container
				cont2.put(hRAW.getByteArray());
			// Initialize The History Work Area
				hWAW.setByteArray(hwa); 
			// Write History Work Area to container
				cont3.put(hWAW.getByteArray());
			// Write History Element List to container
			//	cont4.put(HistoryElement);	Already written, no need to rewrite
// 3nd LINK to the "bridge" with the channel to get History info
				p.link(chanOne);
			// History request container read
				rspRequestCont = chanOne.getContainer(rqstCont);
				rspHstRequestArea = rspRequestCont.get();
			// Move the data to cData byte array in Account Request wrapper
				hRAW.setByteArray(rspHstRequestArea);
			// History Work container read
				rspWorkCont = chanOne.getContainer(workCont);
				rspHstWorkArea = rspWorkCont.get();
			// Move the data to cData byte array in Account Request wrapper
				hWAW.setByteArray(rspHstWorkArea);
				 
				if ( hRAW.getReturnCode().equals("14") ) {
					t.out.println("No records found OR we are at the end of file");  
					exhibiT0700 (prw, Q, rowCounter, aBalance, totHbal, tn, caW, aQLW, eQLW);
					return; //  GOTO 0700-EXHIBIT 
				}
				else
				if ( !hRAW.getReturnCode().equals("  ") ) {
				prw.println("make sure the connection to MUF is established");
				 // Move QLineC and write it to TDQ.
				for (int j = 0; j < 132; j++) {
					tdq[j] = (byte)0x40;}	 
				cQLW.setByteArray(tdq);									// l#1
				cQLW.setQlineC1(userIdBlock);							// l#2
				cQLW.setQlineC2(hWAW.getAccountId());					// l#3
				cQLW.setQlineC3(hWAW.getBranchId());					// l#4
				/* this is packed  										   l#5 */
				cQLW.setQlineC4(String.valueOf(pd.getInt(hWAW.getAmtByteArray())));
				cQLW.setQlineC5(hWAW.getAddDate());						// l#6
				cQLW.setQlineC6(hWAW.getVerDate());						// l#7
				cQLW.setQlineC7(hWAW.getTranNum());						// l#8
				cQLW.setQlineC8(hWAW.gettellerId());					// l#9
				cQLW.setQlineC9(HistoryElement);						// l#10
				writeTDQ (prw, Q, cQLW.getByteArray());       
				 // Move QLineB and write it to TDQ.
				for (int j = 0; j < 132; j++) {
					tdq[j] = (byte)0x40;}	 
				bQLW.setByteArray(tdq);									// l#1
				bQLW.setQlineB1(hRAW.getCommand());						// l#2
				bQLW.setQlineB2(hRAW.getTableName());					// l#3
				bQLW.setQlineB3(hRAW.getKeyName());						// l#4
				bQLW.setQlineB4(hRAW.getReturnCode());					// l#5
				bQLW.setQlineB5(hRAW.getiReturnCode());					// l#6
				 
				byte [] arr = hRAW.getDbid().getBytes();				// DBID
				ByteBuffer bb = ByteBuffer.wrap(arr);
				ShortBuffer sb = bb.asShortBuffer();
				short s1 = sb.get();
				bQLW.setQlineB6(Short.toString(s1));  
				 
				arr = hRAW.getTblid().getBytes();						// TBLID
				bb = ByteBuffer.wrap(arr);
				sb = bb.asShortBuffer();
				s1 = sb.get();
				bQLW.setQlineB7(Short.toString(s1));  
				 
				bQLW.setQlineB8(hRAW.getRecid());						// l#9
				bQLW.setQlineB9A(hRAW.getKeyBid());						// l#10
				bQLW.setQlineB9B(hRAW.getKeyAid());						// l#11
				bQLW.setQlineB9C(hRAW.getTran());						// l#12
				writeTDQ (prw, Q, bQLW.getByteArray());  
				 // Move Request Key from History WA, write it to TDQ.  
				dQLW.setBuffer(hRAW.getKey());							// l#1
				writeTDQ (prw, Q, dQLW.getByteArray());  
				 // Move QLineD and write it to TDQ. 
				for (int j = 0; j < 132; j++) {
					tdq[j] = (byte)0x40;}	 
				dQLW.setByteArray(tdq);									// l#1
				dQLW.setQlineD1("*** ERROR TRAN# ");					// L#2	
				dQLW.setQlineD2(caW.getTrancount());					// l#3
				dQLW.setQlineD11(" AID/BID= ");							// l#4
				dQLW.setQlineD3(caW.getAid());							// l#5
				dQLW.setQlineD4(caW.getBid());							// l#6
				dQLW.setQlineD5(caW.getDbid());							// l#7
				dQLW.setQlineD6(aRAW.getReturnCode());					// l#8
				dQLW.setQlineD7(" TAS# ");								// l#9
				dQLW.setQlineD8(Integer.toString(tn)); 					// l#10  
				dQLW.setQlineD9("  TIME ");								// l#11
				dQLW.setQlineD10(ti);									// l#12
				writeTDQ (prw, Q, dQLW.getByteArray());  
				return; //  GOTO 999-END.
				}  
			// If branch or account number are different then get out.	
				if (!hWAW.getBranchId().equals(caW.getBid())) {
					t.out.println("      got to LOCATION - 08               ");  
					exhibiT0700 (prw, Q, rowCounter, aBalance, totHbal, tn, caW, aQLW, eQLW);
					t.out.println("      got to LOCATION - 09               ");  
					return; //  GOTO 0700-EXHIBIT 
				}
				else
				if (!hWAW.getAccountId().equals(caW.getAid())) {
					prw.println("      got to LOCATION - 10               ");  
			//		prw.println(" hWAW.getAccountId() : " + hWAW.getAccountId());
			//		prw.println(" caW.getAid() : "+ caW.getAid());
					exhibiT0700 (prw, Q, rowCounter, aBalance, totHbal, tn, caW, aQLW, eQLW);
					t.out.println("      got to LOCATION - 11               ");  
					return; //  GOTO 0700-EXHIBIT 
				}
			// COMPUTE TOT-HBAL = TOT-HBAL + HST-AMOUNT  (convert this to java)
				t.out.println("      got to LOCATION - 12               ");  
				totHbal += pd.getInt(hWAW.getAmtByteArray());
				t.out.println("      got to LOCATION - 13               ");  
				rowCounter++;				
	//			if (t != null) return;	//* Just for diagnostic purposes; take it out later
	//* TEMP OUT }
				t.out.println("BOTTOM OF THE LOOP   BOTTOM OF THE LOOP");  
			}	}									// close loop bracket
// BOTTOM OF LOOP
// BOTTOM OF LOOP
// BOTTOM OF LOOP
	 
			 catch (ContainerErrorException e) {
 				t.err.println("No Response Container returned");
 			} catch (ChannelErrorException e) {
 				t.err.println("Channel error returned");
 			} catch (InvalidRequestException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (CCSIDErrorException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (CodePageErrorException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (LengthErrorException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (InvalidSystemIdException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (NotAuthorisedException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (InvalidProgramIdException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (RolledBackException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (TerminalException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
	
				finally {
				// outWriter.println("Leaving writeTDQ()");
				prw.println(" ");}	 
	 
	return;
	}

	//  top of writeTDQ
//  top of writeTDQ
//  top of writeTDQ
	private static void writeTDQ (PrintWriter outWriter, TDQ Q, byte[] data)
	{
		byte[] tdqData;
		tdqData = data;
		outWriter.println("Entering writeTDQ()");
		try
		{
			Q.writeData(tdqData);			// write TDQ
		}
		catch(Throwable T)
			{
		   outWriter.print("TestOne: ");
		   outWriter.println("caught unexpected Throwable (" + 
								   T.toString() +
								   ")");
			}
		finally
			{
		   outWriter.println("Leaving writeTDQ()");
			}
		return;
	}
	 
//  top of exhibiT0700
//  top of exhibiT0700
//  top of exhibiT0700
	private static void exhibiT0700 (PrintWriter outWriter, TDQ Q, int rows, int aBalance, int totHbal, int tn, CommareaWrapper caW, AQlineWrapper aQLW, EQlineWrapper eQLW) {
	byte tdq[] = new byte [132];	 
	int r = rows;
	int aBal = aBalance, totHb = totHbal; 
	outWriter.println("  aBalance : " + Integer.toString(aBalance));
	outWriter.println("  totHbal : " + Integer.toString(totHbal));
	// Date and time formatting
	String ti;
	Calendar c = Calendar.getInstance();
	
	System.out.println("timezone default: " + c.getTimeZone());
	
	
//	DateFormat formatter1 = new SimpleDateFormat("hh:mm:ss:SSS a zzzz"); zone in characters
//	DateFormat formatter1 = new SimpleDateFormat("hh:mm:ss:SSS a Z");  zone in numbers
	DateFormat formatter1 = new SimpleDateFormat("HH:mm:ss:SSS");
	ti = formatter1.format(c.getTime());
	
	if (r < 1) {									// *** tested ***
		for (int j = 0; j < 132; j++) {
			tdq[j] = (byte)0x40;}	 
		eQLW.setByteArray(tdq);										// l#1
		eQLW.setQlineE1(ti);										// l#2
		eQLW.setQlineE2(" ** ERROR NO RECORD FOUND ");				// l#3
		eQLW.setQlineE3(caW.getAid());								// l#4
		eQLW.setQlineE4(caW.getBid());								// l#5
		eQLW.setQlineE5(caW.getTrancount());						// l#6
		eQLW.setQlineE6(caW.getDbid());								// l#7
		writeTDQ (outWriter, Q, eQLW.getByteArray());				// l#8
		return;
		// go to 999-END.  make it go there(basically get out totally)
	}
	else
		if (aBal == totHb)  						// *** tested ***
		{
			outWriter.println("      got to LOCATION - 20.00             "); 
			for (int j = 0; j < 132; j++) {
				tdq[j] = (byte)0x40;}	 
			aQLW.setByteArray(tdq);									// l#1
			aQLW.setQlineA1("NXJR OK ");							// l#2
			aQLW.setQlineA2(caW.getDbid());							// l#3
			aQLW.setQlineA3(" TRAN# ");								// l#4
			aQLW.setQlineA4(caW.getTrancount());					// l#5
			aQLW.setQlineA5(" AID/BID= ");							// l#6
			aQLW.setQlineA7(caW.getAid());							// l#7
			aQLW.setQlineA6(caW.getBid());							// l#8
			aQLW.setQlineA8(" ABAL=");								// l#9
			aQLW.setQlineA9(Integer.toString(aBal));				// l#10
			aQLW.setQlineA10(" ROWS=");								// l#11
			aQLW.setQlineA11(Integer.toString(r));					// l#12
			aQLW.setQlineA12(" TAS#");								// l#13
			aQLW.setQlineA13(Integer.toString(tn));  				// l#14
			aQLW.setQlineA14(" TIME ");								// l#15
			aQLW.setQlineA15(ti);									// l#16
			writeTDQ (outWriter, Q, aQLW.getByteArray());           // l#17
			return;
		}
		else
		{											// *** tested ***
			for (int j = 0; j < 132; j++) {
				tdq[j] = (byte)0x40;}	 
			eQLW.setByteArray(tdq);									// l#1
			eQLW.setQlineE1(ti);									// l#2
			eQLW.setQlineE2(" ** ERROR BALANCE  ");					// l#3
			eQLW.setQlineE3(caW.getAid());							// l#4
			eQLW.setQlineE4(caW.getBid());							// l#5
			eQLW.setQlineE5(caW.getTrancount());					// l#6
			eQLW.setQlineE6(caW.getDbid());							// l#7
			eQLW.setQlineE7(Integer.toString(aBal));				// l#8
			eQLW.setQlineE8(Integer.toString(totHb));				// l#9
			eQLW.setQlineE9(Integer.toString(r));					// l#11
			writeTDQ (outWriter, Q, eQLW.getByteArray());			// l#12
			 
			// go to 999-END.  make it go there(basically get out totally)
		}
	 
	 return;     // this is the 999-END label equivalent (I hope!)
	 // private static final PackedDecimalAsIntField PackedDecimalAsIntField = null;
	}
	}






