package dbc.r15.sample.b4xxntjr;

public class HstWorkAreaWrapper {
	private final int[] HST_BUFFER = {0, 55};
	private final int[] HST_BRANCH_ID = {0, 9};
	private final int[] HST_ACCOUNT_ID = {9, 9};
	private final int[] HST_TRANNUM = {18, 15};
	private final int[] HST_AMOUNT = {33, 5};	// This is signed packed data
	private final int[] HST_ADDDATE = {36, 4};
	private final int[] HST_VERDATE = {40, 4};
	private final int[] HST_TELLER_ID = {44, 9}; 
	// Variable to hold the binary data in the container 
	 
	private byte[] hData;
	
	 /* Set the binary data of container */
	public void setByteArray(byte[] data) { hData = data;}
	 
	/* Get the binary data of the container */
	public byte[] getByteArray() {return hData;}
	 
	public void setBranchId(String newValue) {setNewValue(newValue, HST_BRANCH_ID[0], HST_BRANCH_ID[1]);
	}
	public String getBranchId() {return new String(hData, HST_BRANCH_ID[0], HST_BRANCH_ID[1]);
	}
	public void setAccountId(String newValue) {setNewValue(newValue, HST_ACCOUNT_ID[0], HST_ACCOUNT_ID[1]);
	}
	public String getAccountId() {return new String(hData, HST_ACCOUNT_ID[0], HST_ACCOUNT_ID[1]);
	}
	public void setTranNum(String newValue) {setNewValue(newValue, HST_TRANNUM[0], HST_TRANNUM[1]);
	}
	public String getTranNum() {return new String(hData, HST_TRANNUM[0], HST_TRANNUM[1]);
	}
	public void setAmount(String newValue) {setNewValue(newValue, HST_AMOUNT[0], HST_AMOUNT[1]);
	}
	public String getAmount() {return new String(hData, HST_AMOUNT[0], HST_AMOUNT[1]);
	}
	/* public byte[] getAmByteArray(){
	 *	byte[] b = toByteArray(hData, HST_AMOUNT[0], HST_AMOUNT[1]);
	 *}
	 */
	public byte[] getAmtByteArray(){
	String s;
	s = new String(hData, HST_AMOUNT[0], HST_AMOUNT[1]);
	return s.getBytes();
	}
	public void setAddDate(String newValue) {setNewValue(newValue, HST_ADDDATE[0], HST_ADDDATE[1]);
	}
	public String getAddDate() {return new String(hData, HST_ADDDATE[0], HST_ADDDATE[1]);
	}
	public void setVerDate(String newValue) {setNewValue(newValue, HST_VERDATE[0], HST_VERDATE[1]);
	}
	public String getVerDate() {return new String(hData, HST_VERDATE[0], HST_VERDATE[1]);
	}
	public void setTellerId(String newValue) {setNewValue(newValue, HST_TELLER_ID[0], HST_TELLER_ID[1]);
	}
	public String gettellerId() {return new String(hData, HST_TELLER_ID[0], HST_TELLER_ID[1]);
	}
	 
	/* Inserts a value into the main byte[] and pads with spaces if necessary.
	 * Note: values will be left justified
	 */
	private void setNewValue(String newValue, int index, int length) {
		/* 1. create a new byte array to hold the string called tData for temporary data
		 * 2. copy the new tData byte array to the cData byte array one byte at a time
		 * 3. pad the cData with spaces up to the length passed in on the call 
		 */
		byte tData[] = newValue.getBytes();		// .step 1.
		int tDatalen = tData.length;
		int cDatalen = hData.length;
		int i = 0;
		while ( i < length && index < cDatalen)
		{
			if ( i < tDatalen )
				hData[index++] = tData[i];
			else
				hData[index++] = 0x40;			
			i++;
		}
	}
}
