package dbc.r15.sample.b4xxntju;
import java.io.PrintWriter;
import java.nio.ByteBuffer;
import java.nio.ShortBuffer;
import java.util.*;
import java.text.*;

import com.ibm.cics.server.CCSIDErrorException;
import com.ibm.cics.server.Channel;
import com.ibm.cics.server.ChannelErrorException;
import com.ibm.cics.server.CicsException;
import com.ibm.cics.server.CodePageErrorException;
import com.ibm.cics.server.CommAreaHolder;
import com.ibm.cics.server.Container;
import com.ibm.cics.server.ContainerErrorException;
import com.ibm.cics.server.EndOfDataException;
import com.ibm.cics.server.InvalidProgramIdException;
import com.ibm.cics.server.InvalidRequestException;
import com.ibm.cics.server.InvalidSystemIdException;
import com.ibm.cics.server.LengthErrorException;
import com.ibm.cics.server.NotAuthorisedException;
import com.ibm.cics.server.Program;
import com.ibm.cics.server.RetrieveBits;
import com.ibm.cics.server.RetrievedDataHolder;
import com.ibm.cics.server.RolledBackException;
import com.ibm.cics.server.TDQ;
import com.ibm.cics.server.Task;
import com.ibm.cics.server.TerminalException;
import com.ibm.cics.server.TerminalPrincipalFacility;
import com.ibm.jzos.*;
import com.ibm.jzos.fields.ExternalDecimalAsIntField;
import com.ibm.jzos.fields.PackedDecimalAsIntField;
import com.ibm.jzos.fields.CobolDatatypeFactory;

public class B4XXNTJU {
	
	static String AccountElement = "SQLEL           ";
	static String HistoryElement = "SQLEL           ";
	static String TellerElement  = "SQLEL           ";
	static String BranchElement  = "SQLEL           ";
	// User Id Block container name.
	static String userIdBlock	  = "      QA-NTJU V1 03/01/2013     ";  
	// The five container names and the channel name
	static String userIdCont      = "UsrInfoContainer";    // cont1     
	static String rqstCont        = "RqstContainer   ";    // cont2     
	static String workCont        = "WorkContainer   ";    // cont3     
	static String elmtLstCont     = "ElmtLstContainer";    // cont4     
	static String rqaCont         = "RQAContainer    ";    // cont5
	static String testChannelName = "TestChannelBRAPR";    // chanOne
	
	public static void main(CommAreaHolder CAH) {
	//byte MyCommArea[] = CAH.value;  // T1 ** TEMP CODE FOR TESTING **    //this out
	// Instantiate the wrapper class for account, history and various Qline classes
	CommareaWrapperU caW  = new CommareaWrapperU();			// commarea wrapper
	RqstAreaWrapperU aRAW = new RqstAreaWrapperU(); 		// account request area wrapper
	RqstAreaWrapperU bRAW = new RqstAreaWrapperU();			// branch request area wrapper
	RqstAreaWrapperU tRAW = new RqstAreaWrapperU();			// teller request area wrapper
	RqstAreaWrapperU hRAW = new RqstAreaWrapperU();			// history request area wrapper
	RqstAreaWrapperU lRAW = new RqstAreaWrapperU();			// log request area wrapper
	AccWorkAreaWrapperU aWAW = new AccWorkAreaWrapperU(); 	// account WAW
	BrnWorkAreaWrapperU bWAW = new BrnWorkAreaWrapperU();	// branch WAW
	TelWorkAreaWrapperU tWAW = new TelWorkAreaWrapperU(); 	// teller WAW
	HstWorkAreaWrapperU hWAW = new HstWorkAreaWrapperU(); 	// history WAW
	AQlineWrapperU aQLW = new AQlineWrapperU();
	BQlineWrapperU bQLW = new BQlineWrapperU();
	CQlineWrapperU cQLW = new CQlineWrapperU();
	DQlineWrapperU dQLW = new DQlineWrapperU();
	PackedDecimalAsIntField pd = new PackedDecimalAsIntField(0, 9, true);
	
	int accountBalance = 0, tellerBalance = 0, branchBalance = 0, startAmount = 0;
	int insDate = 324930585;
	// define Account request Area byte array		                            
	byte ra[] = new byte [256];							
	for (int j = 0; j < 256; j++) {
		ra[j] = (byte)0x00;
	}
	// define Account Work Area byte array		                            
	byte awa[] = new byte [100];						
	for (int j = 0; j < 100; j++) {
		awa[j] = (byte)0x00;
	}
	// define History Work Area byte array		                            
	byte hwa[] = new byte [55];							
	for (int j = 0; j < 55; j++) {
		hwa[j] = (byte)0x00;
	}
	// define History Work Area byte array		                            
	byte tdq[] = new byte [132];						
	for (int j = 0; j < 132; j++) {
		tdq[j] = (byte)0x40;	 
	}		 
	// Create the TDQ object
	TDQ Q = new TDQ();
	Q.setName("B400");  
	// Date and time formatting
	String ti;
	Calendar c = Calendar.getInstance();
	//* DateFormat formatter1 = new SimpleDateFormat("HH:mm:ss");	// seconds format
	DateFormat formatter1 = new SimpleDateFormat("HH:mm:ss:SSS");	// thousands of a second format
	ti = formatter1.format(c.getTime());
	// get access to task    
	Task t = null;
	int tn = 0;
	PrintWriter prw = null;
	try {
		t = Task.getTask();
		tn = t.getTaskNumber();
		prw = t.out;
		//caW.setByteArray(MyCommArea);		       			    //this out	T2
		//prw.println("Entering program B4XXNTJU with COMMAREA : " + caW.getBuffer()); //T3 this out
				//t.out.println("Entering Program B4XXNTJU.main(2)");
//*				if (t != null) return;
		RetrievedDataHolder rdh = new RetrievedDataHolder();	//this in   T4
		BitSet whatToRetrieve = new BitSet();					//this in	T5
		whatToRetrieve.set(RetrieveBits.DATA);					//this in	T6
		try {													//this in	T7
			t.retrieve(whatToRetrieve, rdh);					//this in	T8
			System.out.println("Retrieved DATA :" + new String(rdh.value.data)); //this in   T9
			} catch (EndOfDataException e) {					//this in	T10
				System.err.append("No data to retrieve. Did you start the transaction from a terminal ?");
				return;											//this in	T11	
			} catch (CicsException e) {							//this in	T12
				e.printStackTrace();							//this in	T13
				return;											//this in	T14
			}													//this in	T15
		finally { }												//this in	T16
// Create a Channel to pass to the "bridge" program
		Channel chanOne = t.createChannel(testChannelName);

//Create 4 Containers to hold the "User-Id","request area", "work area", "element list"  
		Container cont1 = chanOne.createContainer(userIdCont); 
		Container cont2 = chanOne.createContainer(rqstCont);
		Container cont3 = chanOne.createContainer(workCont);
		Container cont4 = chanOne.createContainer(elmtLstCont);
		//write User_ID block to container
		cont1.put(userIdBlock); 
		// Initialize the commarea Wrapper						
		caW.setByteArray(rdh.value.data);						//this in T17
//*		caW.setByteArray(MyCommArea);
// this is broken startAmount = Integer.valueOf(caW.getStartAmount()); // Amount from commarea
	//	startAmount = edai.getInt(caW.getAmtByteArray());
	//	cQLW.setQlineC4(String.valueOf(pd.getInt(aWAW.getAmtByteArray())));
	//?	prw.println("START Amount $ : " + String.valueOf(startAmount)); 
		// Get the first Account record
		aRAW.setByteArray(ra);		   	   	 // Initialize request area wrapper
		aRAW.setCommand("RDUKY");		   	 // Command
		aRAW.setTableName("ACC");          	 // Table name
		aRAW.setKeyName("SQ004");          	 // Key name
		//urs = Short.valueOf(caW.getDbid());  // DBID
		aRAW.setDbid(Short.valueOf(caW.getDbid()));  // combined with above line
		aRAW.setKeyBid(caW.getBid());	     // Request Key BID
		aRAW.setKeyAid(caW.getAid());	   	 // Request Key Aid
		// write Account Request Area to container
		cont2.put(aRAW.getByteArray());					
		// Initialize The Account Work Area
		aWAW.setByteArray(awa); 
		aWAW.setAddDate(insDate);
		aWAW.setVerDate(insDate);
		// write Account Work Area to container
		cont3.put(aWAW.getByteArray());					
		// Write Account Element List to container
		cont4.put(AccountElement);
		// Create the Program object and set the program name
		Program p = new Program();
		p.setName("DCBRAPR");
// 1st LINK to the "bridge" with the channel to get Account info
		p.link(chanOne);
		// Account request container read
		Container rspRequestCont = chanOne.getContainer(rqstCont);
		byte[] rspAccRequestData = rspRequestCont.get();
		// move the data to cData byte array in Account Request wrapper
		aRAW.setByteArray(rspAccRequestData);
		// read in Account Work container
		Container rspWorkCont = chanOne.getContainer(workCont);
		byte[] rspAccWorkData = rspWorkCont.get();
		// move the data to cData byte array in Account Work wrapper
		aWAW.setByteArray(rspAccWorkData);
				
		if ( !aRAW.getReturnCode().equals("  ") ){   
			prw.println("make sure the connection to MUF is established");
			// Move QLineC and write it to transient Q.
			for (int j = 0; j < 132; j++) {
				tdq[j] = (byte)0x40;}	 
				cQLW.setByteArray(tdq);									// l#1
				cQLW.setQlineC1(userIdBlock);							// l#2
				cQLW.setQlineC2(aWAW.getAccountId());					// l#3
				cQLW.setQlineC3(aWAW.getBranchId());					// l#4
				/*   This is packed                                        l#5 */
				cQLW.setQlineC4(String.valueOf(pd.getInt(aWAW.getAmtByteArray())));
				cQLW.setQlineC5(aWAW.getAddDate());						// l#6
				cQLW.setQlineC6(aWAW.getVerDate());						// l#7
				cQLW.setQlineC7(AccountElement);						// l#8
				writeTDQ (prw, Q, cQLW.getByteArray());        			
				
				for (int j = 0; j < 132; j++) {
					tdq[j] = (byte)0x40;}	 
				bQLW.setByteArray(tdq);									// l#1
				bQLW.setQlineB1(aRAW.getCommand());						// l#2
				bQLW.setQlineB2(aRAW.getTableName());					// l#3
				bQLW.setQlineB3(aRAW.getKeyName());						// l#4
				bQLW.setQlineB4(aRAW.getReturnCode());					// l#5
				bQLW.setQlineB5(aRAW.getiReturnCode());					// l#6
					 
				byte [] arr = aRAW.getDbid().getBytes();				// DBID
				ByteBuffer bb = ByteBuffer.wrap(arr);
				ShortBuffer sb = bb.asShortBuffer();
				short s1 = sb.get();
				bQLW.setQlineB6(Short.toString(s1));  
					 
				arr = aRAW.getTblid().getBytes();						// TBLID
				bb = ByteBuffer.wrap(arr);
				sb = bb.asShortBuffer();
				s1 = sb.get();
				bQLW.setQlineB7(Short.toString(s1));  
					
				bQLW.setQlineB8(aRAW.getRecid());						// l#9
				bQLW.setQlineB9A(aRAW.getKeyBid());						// l#10
				bQLW.setQlineB9B(aRAW.getKeyAid());						// l#11
				writeTDQ (prw, Q, bQLW.getByteArray());  
		     
				for (int j = 0; j < 132; j++) {
					tdq[j] = (byte)0x40;}	 
				//prw.println("  ACC # 01        ");
				dQLW.setByteArray(tdq);									// l#1
				//prw.println("  ACC # 02        ");
				dQLW.setQlineD1("*** ERROR TRAN# ");					// L#2	
				dQLW.setQlineD2(caW.getTrancount());					// l#3
				//prw.println("  ACC # 03         ");
				dQLW.setQlineD5(" AID= ");								// l#4
				dQLW.setQlineD6(caW.getAid());							// L#5
				//prw.println("  ACC # 04         ");
				dQLW.setQlineD7(" ACC RDUKY CODE= ");					// l#6
				dQLW.setQlineD8(aRAW.getReturnCode());					// l#7
				//prw.println("  ACC # 05         ");
				//int irc = Integer.parseInt(aRAW.getiReturnCode(), 16); 	// HEX byte to int 
				//dQLW.setQlineD9(Integer.toString(irc));					// Display irc
				byte b0 = aRAW.getiReturnCode().getBytes()[0];			// hexString TO hexByte
				s1 = (short)(0xff & b0);
				dQLW.setQlineD9(Short.toString(s1)); 					// l#8 
				dQLW.setQlineD3(" TAS# ");								// l#9
				dQLW.setQlineD4(Integer.toString(tn)); 					// l#10  
				//prw.println("  ACC # 06         ");
				dQLW.setQlineD10(" TIME ");								// l#11
				dQLW.setQlineD11(ti);									// l#12
				//prw.println("  ACC # 07         ");
				writeTDQ (prw, Q, dQLW.getByteArray());  		
				//prw.println("  ACC # 08         ");
				Abend998 (t, p, prw, Q, tn, caW, bQLW, dQLW, lRAW, chanOne, cont2);
				return; 				
			}
		byte sam[] = caW.getAmtByteArray();			// startAmount
		byte sam9 = (byte)(sam[9] | (byte)0xf0);	// Suppress the sign
		sam[9] = sam9;								// put the byte back with sign suppressed
		String samS = new String(sam);
		startAmount = Integer.valueOf(samS);
		//****************
		accountBalance = pd.getInt(aWAW.getAmtByteArray());
		accountBalance += startAmount;
		//prw.println("  ACC BALANCE =  " + sam9S + " ACC TOTALS = "  + String.valueOf(accountBalance));
		byte ba[] = new byte [5]; 	
		pd.putInt(accountBalance, ba);         // place the packed field in the byte array
		aWAW.setAccountBal(new String(ba));	   // convert to string and set it in WA				
		// Update with the new account balance in the " account work area " 
		t.out.println("");  				   // skip a line
		t.out.println("      got to LOCATION - 01               ");  		   
		aRAW.setCommand("UPDAT");		 	   // Command
		// Write Account Request Area to container
		cont2.put(aRAW.getByteArray());
		// Write Account Work Area to container
		aWAW.setAddDate(insDate);
		aWAW.setVerDate(insDate);
		cont3.put(aWAW.getByteArray());			// balance was already updated
// 2nd LINK to the "bridge" with the channel to update Account Balance
		p.link(chanOne);
		t.out.println("      Wrote back updated Account balance           ");  
		// Account request container read			
		rspRequestCont = chanOne.getContainer(rqstCont);
		// Move the data to cData byte array in History Request wrapper
		aRAW.setByteArray(rspAccRequestData);
				
		if ( !aRAW.getReturnCode().equals("  ") ) {		
			prw.println("make sure the connection to MUF is established");
			// Move QLineC and write it to TDQ.
			for (int j = 0; j < 132; j++) {
				tdq[j] = (byte)0x40;}
			cQLW.setByteArray(tdq);									// l#1
			//prw.println("  ACC # 11        ");
			cQLW.setQlineC1(userIdBlock);							// l#2
			cQLW.setQlineC2(aWAW.getAccountId());					// l#3
			cQLW.setQlineC3(aWAW.getBranchId());					// l#4
			/* this is packed  										   l#5 */
			cQLW.setQlineC4(String.valueOf(pd.getInt(aWAW.getAmtByteArray())));
			cQLW.setQlineC5(aWAW.getAddDate());						// l#6
			cQLW.setQlineC6(aWAW.getVerDate());						// l#7
			cQLW.setQlineC7(HistoryElement);						// l#8
			writeTDQ (prw, Q, cQLW.getByteArray());     
		
			for (int j = 0; j < 132; j++) {
				tdq[j] = (byte)0x40;}	 
			bQLW.setByteArray(tdq);									// l#1
			//prw.println("  ACC # 21        ");
			bQLW.setQlineB1(aRAW.getCommand());						// l#2
			bQLW.setQlineB2(aRAW.getTableName());					// l#3
			bQLW.setQlineB3(aRAW.getKeyName());						// l#4
			bQLW.setQlineB4(aRAW.getReturnCode());					// l#5
			bQLW.setQlineB5(aRAW.getiReturnCode());					// l#6
				 
			byte [] arr = aRAW.getDbid().getBytes();				// DBID
			ByteBuffer bb = ByteBuffer.wrap(arr);
			ShortBuffer sb = bb.asShortBuffer();
			short s1 = sb.get();
			bQLW.setQlineB6(Short.toString(s1));  
				 
			arr = aRAW.getTblid().getBytes();						// TBLID
			bb = ByteBuffer.wrap(arr);
			sb = bb.asShortBuffer();
			s1 = sb.get();
			bQLW.setQlineB7(Short.toString(s1));  
				 
			bQLW.setQlineB8(aRAW.getRecid());						// l#9
			bQLW.setQlineB9A(aRAW.getKeyBid());						// l#10
			bQLW.setQlineB9B(aRAW.getKeyAid());						// l#11
			writeTDQ (prw, Q, bQLW.getByteArray());  		
		
			for (int j = 0; j < 132; j++) {
				tdq[j] = (byte)0x40;}	 
			dQLW.setByteArray(tdq);									// l#1
			//prw.println("  ACC # 31        ");
			dQLW.setQlineD1("*** ERROR TRAN# ");					// L#2	
			dQLW.setQlineD2(caW.getTrancount());					// l#3
			dQLW.setQlineD5(" AID# ");								// l#4
			dQLW.setQlineD6(caW.getAid());							// l#5
			dQLW.setQlineD7(" ACC UPDAT CODE= ");					// l#6
			dQLW.setQlineD8(aRAW.getReturnCode());					// l#7
			//int irc = Integer.parseInt(aRAW.getiReturnCode(), 16); 	// HEX byte to int 
			//dQLW.setQlineD9(Integer.toString(irc));					// Display irc
			byte b0 = aRAW.getiReturnCode().getBytes()[0];			// hexString TO hexByte
			s1 = (short)(0xff & b0);
			dQLW.setQlineD9(Short.toString(s1)); 					// l#8 
			dQLW.setQlineD3(" TAS# ");								// l#9
			dQLW.setQlineD4(Integer.toString(tn)); 					// l#10   
			dQLW.setQlineD10("  TIME ");							// l#11
			dQLW.setQlineD11(ti);									// l#12
			writeTDQ (prw, Q, dQLW.getByteArray());  		
			Abend998 (t, p, prw, Q, tn, caW, bQLW, dQLW, lRAW, chanOne, cont2);
			return; 
		}
//******************* DO THE TELLER **********************************
			// Initialize the Teller Request Area
		tRAW.setByteArray(ra);		   	   	 // Initialize request area wrapper
		tRAW.setCommand("RDUKY");		   	 // Command
		tRAW.setTableName("TEL");          	 // Table name
		tRAW.setKeyName("SQ002");          	 // Key name			tRAW.setDbid(Short.valueOf(caW.getDbid()));  // DBID
		tRAW.setKeyTel(caW.getTid());	     // Request Key TID 
		// write Teller Request Area to container
		cont2.put(tRAW.getByteArray());					
		// Initialize The Teller Work Area
		tWAW.setByteArray(awa); 						
		// write Teller Work Area to container
		cont3.put(tWAW.getByteArray());					
		// Write Teller Element List to container
		cont4.put(TellerElement);						
// LINK to the "bridge" with the channel to get Teller info
		p.link(chanOne);
		// Get from Teller request area container 
		rspRequestCont = chanOne.getContainer(rqstCont);
		byte[] rspTelRequestData = rspRequestCont.get();	
		// Move the data to cData byte array in Teller Request wrapper
		tRAW.setByteArray(rspTelRequestData);
		// Get from Teller Work area container
		rspWorkCont = chanOne.getContainer(workCont);
		byte[] rspTelWorkData = rspWorkCont.get();
		// move the data to cData byte array in Account Work wrapper
		tWAW.setByteArray(rspTelWorkData);
				
		if ( !tRAW.getReturnCode().equals("  ") ){ 		
			//prw.println("Abnormal RC from the Teller RDUKY");
		 // Move QLineC and write it to transient Q.
			for (int j = 0; j < 132; j++) {
				tdq[j] = (byte)0x40;}	 
			cQLW.setByteArray(tdq);									// l#1
			//prw.println("  TEL # 01        ");
			cQLW.setQlineC1(userIdBlock);							// l#2
			cQLW.setQlineC2(tWAW.getTellerId());					// l#3
			cQLW.setQlineC3(tWAW.getBranchId());					// l#4
			/*   This is packed                                        l#5 */
			cQLW.setQlineC4(String.valueOf(pd.getInt(tWAW.getAmtByteArray())));
			cQLW.setQlineC7(TellerElement);							// l#7
			writeTDQ (prw, Q, cQLW.getByteArray());       			
		    
			for (int j = 0; j < 132; j++) {
				tdq[j] = (byte)0x40;}	 
			bQLW.setByteArray(tdq);									// l#1
			//prw.println("  TEL # 02        ");
			bQLW.setQlineB1(tRAW.getCommand());						// l#2
			bQLW.setQlineB2(tRAW.getTableName());					// l#3
			bQLW.setQlineB3(tRAW.getKeyName());						// l#4
			bQLW.setQlineB4(tRAW.getReturnCode());					// l#5
			bQLW.setQlineB5(tRAW.getiReturnCode());					// l#6
					 
			byte [] arr = tRAW.getDbid().getBytes();				// DBID
			ByteBuffer bb = ByteBuffer.wrap(arr);
			ShortBuffer sb = bb.asShortBuffer();
			short s1 = sb.get();
			bQLW.setQlineB6(Short.toString(s1));  
					 
			arr = tRAW.getTblid().getBytes();						// TBLID
			bb = ByteBuffer.wrap(arr);
			sb = bb.asShortBuffer();
			s1 = sb.get();
			bQLW.setQlineB7(Short.toString(s1));  
					
			bQLW.setQlineB8(tRAW.getRecid());						// l#9
			bQLW.setQlineB9A(tRAW.getKeyTel());						// l#10
			writeTDQ (prw, Q, bQLW.getByteArray());  	
		    
			for (int j = 0; j < 132; j++) {
				tdq[j] = (byte)0x40;}	 
			dQLW.setByteArray(tdq);									// l#1
			//prw.println("  TEL # 03        ");
			dQLW.setQlineD1("*** ERROR TRAN# ");					// l#2	
			dQLW.setQlineD2(caW.getTrancount());					// l#3
			dQLW.setQlineD5(" TID= ");								// l#4
			dQLW.setQlineD6(caW.getTid());							// l#5
			dQLW.setQlineD7(" TED RDUKY CODE= ");					// l#6
			dQLW.setQlineD8(tRAW.getReturnCode());					// l#7
			//int irc = Integer.parseInt(tRAW.getiReturnCode(), 16); 	// HEX byte to int 
			//dQLW.setQlineD9(Integer.toString(irc));					// Display irc
			byte b0 = tRAW.getiReturnCode().getBytes()[0];			// hexString TO hexByte
			s1 = (short)(0xff & b0);
			dQLW.setQlineD9(Short.toString(s1)); 					// l#8 
			dQLW.setQlineD3(" TAS# ");								// l#9
			dQLW.setQlineD4(Integer.toString(tn)); 					// l#10  
			dQLW.setQlineD10(" TIME ");								// l#11
			dQLW.setQlineD11(ti);									// l#12
			writeTDQ (prw, Q, dQLW.getByteArray());  		
			Abend998 (t, p, prw, Q, tn, caW, bQLW, dQLW, lRAW, chanOne, cont2);
			return; 				
		}	
		tellerBalance = pd.getInt(tWAW.getAmtByteArray());
		tellerBalance += startAmount;
		pd.putInt(tellerBalance, ba);      // place the packed field in the byte array
		tWAW.setAmount(new String(ba));	   // convert to string and set it in tWAW			
		// Update with the new teller balance in the " teller work area " 
		t.out.println("      got to LOCATION - 01  in teller      ");  		   
		tRAW.setCommand("UPDAT");		   // Command
		// Write Account Request Area to container
		cont2.put(tRAW.getByteArray());
		// Write Account Work Area to container
		cont3.put(tWAW.getByteArray());		// balance was already updated
// LINK to the "bridge" with the channel to update Teller Balance
		p.link(chanOne);
		t.out.println("      Wrote back updated Teller balance    "); 
		// Account request container read			
		rspRequestCont = chanOne.getContainer(rqstCont);
		// Move the data to cData byte array in History Request wrapper
		tRAW.setByteArray(rspTelRequestData);
		
		if ( !tRAW.getReturnCode().equals("  ") ){ 	
			//prw.println("make sure the connection to MUF is established");
		 // Move QLineC and write it to transient Q.
			for (int j = 0; j < 132; j++) {
				tdq[j] = (byte)0x40;}	 
			cQLW.setByteArray(tdq);									// l#1
			//prw.println("  TEL # 11        ");
			cQLW.setQlineC1(userIdBlock);							// l#2
			cQLW.setQlineC2(tWAW.getTellerId());					// l#3
			cQLW.setQlineC3(tWAW.getBranchId());					// l#4
			/*   This is packed                                        l#5 */
			cQLW.setQlineC4(String.valueOf(pd.getInt(tWAW.getAmtByteArray())));
			cQLW.setQlineC7(TellerElement);							// l#7
			writeTDQ (prw, Q, cQLW.getByteArray());    	
		    
			for (int j = 0; j < 132; j++) {
				tdq[j] = (byte)0x40;}	 
			bQLW.setByteArray(tdq);									// l#1
			//prw.println("  TEL # 21        ");
			bQLW.setQlineB1(tRAW.getCommand());						// l#2
			bQLW.setQlineB2(tRAW.getTableName());					// l#3
			bQLW.setQlineB3(tRAW.getKeyName());						// l#4
			bQLW.setQlineB4(tRAW.getReturnCode());					// l#5
			bQLW.setQlineB5(tRAW.getiReturnCode());					// l#6
					 
			byte [] arr = tRAW.getDbid().getBytes();				// DBID
			ByteBuffer bb = ByteBuffer.wrap(arr);
			ShortBuffer sb = bb.asShortBuffer();
			short s1 = sb.get();
			bQLW.setQlineB6(Short.toString(s1));  
					 
			arr = tRAW.getTblid().getBytes();						// TBLID
			bb = ByteBuffer.wrap(arr);
			sb = bb.asShortBuffer();
			s1 = sb.get();
			bQLW.setQlineB7(Short.toString(s1));  
					
			bQLW.setQlineB8(tRAW.getRecid());						// l#9
			bQLW.setQlineB9A(tRAW.getKeyTel());						// l#10
			writeTDQ (prw, Q, bQLW.getByteArray());  
		    // Move QLineD and write it to TDQ.
			for (int j = 0; j < 132; j++) {
				tdq[j] = (byte)0x40;}	 
			dQLW.setByteArray(tdq);									// l#1
			//prw.println("  TEL # 31        ");
			dQLW.setQlineD1("*** ERROR TRAN# ");					// L#2	
			dQLW.setQlineD2(caW.getTrancount());					// l#3
			dQLW.setQlineD5(" TID= ");								// l#4
			dQLW.setQlineD6(caW.getTid());							// l#5
			dQLW.setQlineD7(" TED RDUKY CODE= ");					// l#6
			dQLW.setQlineD8(tRAW.getReturnCode());					// l#7
			//int irc = Integer.parseInt(tRAW.getiReturnCode(), 16); 	// HEX byte to int 
			//dQLW.setQlineD9(Integer.toString(irc));					// Display irc
			byte b0 = tRAW.getiReturnCode().getBytes()[0];			// hexString TO hexByte
			s1 = (short)(0xff & b0);
			dQLW.setQlineD9(Short.toString(s1)); 					// l#8 
			dQLW.setQlineD3(" TAS# ");								// l#9
			dQLW.setQlineD4(Integer.toString(tn)); 					// l#10  
			dQLW.setQlineD10(" TIME ");								// l#11
			dQLW.setQlineD11(ti);									// l#12
			writeTDQ (prw, Q, dQLW.getByteArray());  		
			Abend998 (t, p, prw, Q, tn, caW, bQLW, dQLW, lRAW, chanOne, cont2);
			return; 
		}
//******************* TELLER CODE ABOVE HERE **********************************
				 
//******************* BRANCH CODE BELOW HERE **********************************
		// Initialize the Branch Request Area
		bRAW.setByteArray(ra);		   	   			 // Initialize request area wrapper
		bRAW.setCommand("RDUKY");		 		  	 // Command
		bRAW.setTableName("BRN");         		 	 // Table name
		bRAW.setKeyName("SQ001");          			 // Key name
		bRAW.setDbid(Short.valueOf(caW.getDbid()));  // DBID
		bRAW.setKeyBrn(caW.getBid());	 		     // Request Key BID 
		// Write Branch Request Area to container
		cont2.put(bRAW.getByteArray());					
		// Initialize The Branch Work Area
		bWAW.setByteArray(awa); 						
		// Write Branch Work Area to container
		cont3.put(bWAW.getByteArray());					
		// Write Branch Element List to container
		cont4.put(BranchElement);						
// LINK to the "bridge" with the channel to get Branch info
		p.link(chanOne);
		// Get from Branch request area container 
		rspRequestCont = chanOne.getContainer(rqstCont);
		byte[] rspBraRequestData = rspRequestCont.get();	
		// Move the data to cData byte array in Branch Request wrapper
		bRAW.setByteArray(rspBraRequestData);
		// Get from Branch Work area container
		rspWorkCont = chanOne.getContainer(workCont);
		byte[] rspBraWorkData = rspWorkCont.get();
		// Move the data to cData byte array in Account Work wrapper
		bWAW.setByteArray(rspBraWorkData);
				
		if ( !bRAW.getReturnCode().equals("  ") ){  
			//prw.println("make sure the connection to MUF is established");
		 // Move QLineC and write it to transient Q.
			for (int j = 0; j < 132; j++) {
				tdq[j] = (byte)0x40;}	 
			cQLW.setByteArray(tdq);									// l#1
			//prw.println("  BRN # 01        ");
			cQLW.setQlineC1(userIdBlock);							// l#2
			cQLW.setQlineC3(bWAW.getBranchId());					// l#4
			/*   This is packed                                        l#5 */
			cQLW.setQlineC4(String.valueOf(pd.getInt(bWAW.getAmtByteArray())));
			cQLW.setQlineC7(BranchElement);							// l#8
			writeTDQ (prw, Q, cQLW.getByteArray());       			
		    // Move QLineB and write it to TDQ.
			for (int j = 0; j < 132; j++) {
				tdq[j] = (byte)0x40;}	 
			bQLW.setByteArray(tdq);									// l#1
			//prw.println("  BRN # 02        ");
			bQLW.setQlineB1(bRAW.getCommand());						// l#2
			bQLW.setQlineB2(bRAW.getTableName());					// l#3
			bQLW.setQlineB3(bRAW.getKeyName());						// l#4
			bQLW.setQlineB4(bRAW.getReturnCode());					// l#5
			bQLW.setQlineB5(bRAW.getiReturnCode());					// l#6
					 
			byte [] arr = bRAW.getDbid().getBytes();				// DBID
			ByteBuffer bb = ByteBuffer.wrap(arr);
			ShortBuffer sb = bb.asShortBuffer();
			short s1 = sb.get();
			bQLW.setQlineB6(Short.toString(s1));  
					 
			arr = bRAW.getTblid().getBytes();						// TBLID
			bb = ByteBuffer.wrap(arr);
			sb = bb.asShortBuffer();
			s1 = sb.get();
			bQLW.setQlineB7(Short.toString(s1));  
					
			bQLW.setQlineB8(bRAW.getRecid());						// l#9
			bQLW.setQlineB9A(bRAW.getKeyTel());						// l#10
			writeTDQ (prw, Q, bQLW.getByteArray());  	
		    
			for (int j = 0; j < 132; j++) {
				tdq[j] = (byte)0x40;}	 
			dQLW.setByteArray(tdq);									// l#1
			//prw.println("  BRN # 03        ");
			dQLW.setQlineD1("*** ERROR TRAN# ");					// L#2	
			dQLW.setQlineD2(caW.getTrancount());					// l#3
			dQLW.setQlineD5(" BID= ");								// l#4
			dQLW.setQlineD6(caW.getBid());							// l#5
			dQLW.setQlineD7(" BRN RDUKY CODE= ");					// l#6
			dQLW.setQlineD8(bRAW.getReturnCode());					// l#7
			//int irc = Integer.parseInt(bRAW.getiReturnCode(), 16); 	// HEX byte to int 
			//dQLW.setQlineD9(Integer.toString(irc));					// Display irc
			byte b0 = bRAW.getiReturnCode().getBytes()[0];			// hexString TO hexByte
			s1 = (short)(0xff & b0);
			dQLW.setQlineD9(Short.toString(s1)); 					// l#8 
			dQLW.setQlineD3(" TAS# ");								// l#9
			dQLW.setQlineD4(Integer.toString(tn)); 					// l#10 
			dQLW.setQlineD10(" TIME ");								// l#11
			dQLW.setQlineD11(ti);									// l#12
			writeTDQ (prw, Q, dQLW.getByteArray());  		
			Abend998 (t, p, prw, Q, tn, caW, bQLW, dQLW, lRAW, chanOne, cont2);
			return; 				
		}
		branchBalance = pd.getInt(bWAW.getAmtByteArray());
		branchBalance += startAmount;
		pd.putInt(branchBalance, ba);      // place the packed field in the byte array
		bWAW.setAmount(new String(ba));	   // convert to string and set it in WA				
		// Update with the new branch balance in the " branch work area " 
		t.out.println("      got to LOCATION - 01  in BRANCH      ");  		   
		bRAW.setCommand("UPDAT");		   // Command
		// Write Branch Request Area to container
		cont2.put(bRAW.getByteArray());
		// Write Branch Work Area to container
		cont3.put(bWAW.getByteArray());		// balance was already updated
// LINK to the "bridge" with the channel to update Branch Balance
		p.link(chanOne);
		t.out.println("      Wrote back updated branch balance    ");  
		// Branch request container read				
		rspRequestCont = chanOne.getContainer(rqstCont);
		// Move the data to cData byte array in History Request wrapper
		bRAW.setByteArray(rspBraRequestData);
		
		if ( !bRAW.getReturnCode().equals("  ") ){ 	
			//prw.println("make sure the connection to MUF is established");
		 // Move QLineC and write it to transient Q.
			for (int j = 0; j < 132; j++) {
				tdq[j] = (byte)0x40;}	 
			cQLW.setByteArray(tdq);									// l#1
			//prw.println("  BRN # 11        ");
			cQLW.setQlineC1(userIdBlock);							// l#2
			cQLW.setQlineC3(bWAW.getBranchId());					// l#4
			/*   This is packed                                        l#5 */
			cQLW.setQlineC4(String.valueOf(pd.getInt(bWAW.getAmtByteArray())));
			cQLW.setQlineC7(BranchElement);							// l#8
			writeTDQ (prw, Q, cQLW.getByteArray());       			
		    // Move QLineB and write it to TDQ.
			for (int j = 0; j < 132; j++) {
				tdq[j] = (byte)0x40;}	 
			bQLW.setByteArray(tdq);									// l#1
			//prw.println("  BRN # 21        ");
			bQLW.setQlineB1(bRAW.getCommand());						// l#2
			bQLW.setQlineB2(bRAW.getTableName());					// l#3
			bQLW.setQlineB3(bRAW.getKeyName());						// l#4
			bQLW.setQlineB4(bRAW.getReturnCode());					// l#5
			bQLW.setQlineB5(bRAW.getiReturnCode());					// l#6
					 
			byte [] arr = bRAW.getDbid().getBytes();				// DBID
			ByteBuffer bb = ByteBuffer.wrap(arr);
			ShortBuffer sb = bb.asShortBuffer();
			short s1 = sb.get();
			bQLW.setQlineB6(Short.toString(s1));  
					 
			arr = bRAW.getTblid().getBytes();						// TBLID
			bb = ByteBuffer.wrap(arr);
			sb = bb.asShortBuffer();
			s1 = sb.get();
			bQLW.setQlineB7(Short.toString(s1));  
					
			bQLW.setQlineB8(bRAW.getRecid());						// l#9
			bQLW.setQlineB9A(bRAW.getKeyTel());						// l#10
			writeTDQ (prw, Q, bQLW.getByteArray());  	
		    // Move QLineD and write it to TDQ.
			for (int j = 0; j < 132; j++) {
				tdq[j] = (byte)0x40;}	 
			dQLW.setByteArray(tdq);									// l#1
			//prw.println("  BRN # 31        ");
			dQLW.setQlineD1("*** ERROR TRAN# ");					// L#2	
			dQLW.setQlineD2(caW.getTrancount());					// l#3
			dQLW.setQlineD5(" BID= ");								// l#4
			dQLW.setQlineD6(caW.getBid());							// l#5
			dQLW.setQlineD7(" BRN RDUKY CODE= ");					// l#6
			dQLW.setQlineD8(bRAW.getReturnCode());					// l#7
			//int irc = Integer.parseInt(bRAW.getiReturnCode(), 16); 	// HEX byte to int 
			//dQLW.setQlineD9(Integer.toString(irc));					// Display irc
			byte b0 = bRAW.getiReturnCode().getBytes()[0];			// hexString TO hexByte
			s1 = (short)(0xff & b0);
			dQLW.setQlineD9(Short.toString(s1)); 					// l#8 
			dQLW.setQlineD3(" TAS# ");								// l#9
			dQLW.setQlineD4(Integer.toString(tn)); 					// l#10  
			dQLW.setQlineD10(" TIME ");								// l#11
			dQLW.setQlineD11(ti);									// l#12
			writeTDQ (prw, Q, dQLW.getByteArray());  		
			Abend998 (t, p, prw, Q, tn, caW, bQLW, dQLW, lRAW, chanOne, cont2);
		return; 
		}
				 
//******************  do HISTORY below *****************************
				 
		// Initialize the History Request Area
		hRAW.setByteArray(ra);		   
		hRAW.setCommand("ADDIT");		   // Command
		hRAW.setTableName("HST");          // Table name
		hRAW.setKeyName("SQ005");          // Key name
		hRAW.setDbid(Short.valueOf(caW.getDbid()));  // DBID
		// Write History Request Area to container
		cont2.put(hRAW.getByteArray());					
		// Initialize The History Work Area
		hWAW.setByteArray(hwa); 				
		hWAW.setAccountId(caW.getAid());   	 // Request Account Id
		hWAW.setTellerId(caW.getTid());   	 // Request Teller Id
		hWAW.setBranchId(caW.getBid());   	 // Request Branch Id
		// move START-AMOUNT to HST-AMOUNT. FROM 10 DECIMAL TO 5 PACKED.
		pd.putInt(startAmount, ba);       	 // place the packed field in the byte array	
		hWAW.setAmount(new String(ba));	     // convert to string and set it in WA	
		hWAW.setTranNum(caW.getTrannum());   // Transaction Number
		hWAW.setAddDate(insDate);
		hWAW.setVerDate(insDate); 
		// Write History Work Area to container
		cont3.put(hWAW.getByteArray());
		// Write History Element List to container
		cont4.put(HistoryElement);							//ok history
// 3rd LINK to the "bridge" with the channel to get History info
		p.link(chanOne);
		t.out.println("      got to LOCATION - 01  in history      "); 
		// History request container read
		rspRequestCont = chanOne.getContainer(rqstCont);
		byte[] rspHstRequestArea = rspRequestCont.get();
		// Move the data to cData byte array in History Request wrapper
		hRAW.setByteArray(rspHstRequestArea);
		// History Work container read
		rspWorkCont = chanOne.getContainer(workCont);
		byte [] rspHstWorkArea = rspWorkCont.get();
		// Move the data to cData byte array in History Request wrapper
		hWAW.setByteArray(rspHstWorkArea);					//ok history
	
		if ( !hRAW.getReturnCode().equals("  ") ) {  // PUT BACK IN THE '!'
			//prw.println("make sure the connection to MUF is established");
			// Move QLineC and write it to TDQ.
			for (int j = 0; j < 132; j++) {
				tdq[j] = (byte)0x40;}	 
			cQLW.setByteArray(tdq);									// l#1
			//prw.println("  HST # 01        ");
			cQLW.setQlineC1(userIdBlock);							// l#2
			cQLW.setQlineC2(hWAW.getAccountId());					// l#3
			cQLW.setQlineC3(hWAW.getBranchId());					// l#4
			/* this is packed  										   l#5 */
			cQLW.setQlineC4(String.valueOf(pd.getInt(hWAW.getAmtByteArray())));
			cQLW.setQlineC5(hWAW.getAddDate());						// l#6
			cQLW.setQlineC6(hWAW.getVerDate());						// l#7
			cQLW.setQlineC7(hWAW.gettellerId());					// l#9
			cQLW.setQlineC8(HistoryElement);						// l#10
			writeTDQ (prw, Q, cQLW.getByteArray());   			//ok history    
			// Move QLineB and write it to TDQ.
			for (int j = 0; j < 132; j++) {
				tdq[j] = (byte)0x40;}	 
			bQLW.setByteArray(tdq);									// l#1
			//prw.println("  HST # 02        ");
			bQLW.setQlineB1(hRAW.getCommand());						// l#2
			bQLW.setQlineB2(hRAW.getTableName());					// l#3
			bQLW.setQlineB3(hRAW.getKeyName());						// l#4
			bQLW.setQlineB4(hRAW.getReturnCode());					// l#5
			bQLW.setQlineB5(hRAW.getiReturnCode());					// l#6
				 
			byte [] arr = hRAW.getDbid().getBytes();				// DBID
			ByteBuffer bb = ByteBuffer.wrap(arr);
			ShortBuffer sb = bb.asShortBuffer();
			short s1 = sb.get();
			bQLW.setQlineB6(Short.toString(s1));  
				 
			arr = hRAW.getTblid().getBytes();						// TBLID
			bb = ByteBuffer.wrap(arr);
			sb = bb.asShortBuffer();
			s1 = sb.get();
			bQLW.setQlineB7(Short.toString(s1));  
				 
			bQLW.setQlineB8(hRAW.getRecid());						// l#9
			writeTDQ (prw, Q, bQLW.getByteArray());  	
			// Move QLineD and write it to TDQ. 
			for (int j = 0; j < 132; j++) {
				tdq[j] = (byte)0x40;}	 
			dQLW.setByteArray(tdq);									// l#1
			dQLW.setByteArray(hRAW.getKeyValue().getBytes());
			writeTDQ (prw, Q, bQLW.getByteArray());  	
			// Move QLineD and write it to TDQ. 
			for (int j = 0; j < 132; j++) {
				tdq[j] = (byte)0x40;}	 
			dQLW.setByteArray(tdq);									// l#1
			//prw.println("  HST # 03        ");
			dQLW.setQlineD1("*** ERROR TRAN# ");					// L#2	
			dQLW.setQlineD2(caW.getTrancount());					// l#3
			dQLW.setQlineD5(" HST# ");								// l#4
			dQLW.setQlineD6(caW.getAid());							// l#5
			dQLW.setQlineD7(" HST ADDIT CODE= ");					// l#6
			dQLW.setQlineD8(hRAW.getReturnCode());					// l#9
			//int irc = Integer.parseInt(hRAW.getiReturnCode(), 16); 	// HEX IRC byte to int 
			//dQLW.setQlineD9(Integer.toString(irc));					// Display IRC
			//prw.println("  HST # 04        ");
			byte b0 = hRAW.getiReturnCode().getBytes()[0];			// hexString TO hexByte
			//prw.println("  HST # 05        ");
			s1 = (short)(0xff & b0);
			//prw.println("  HST # 06        ");
			dQLW.setQlineD9(Short.toString(s1)); 					// l#8 
			//prw.println("  HST # 07        ");
			dQLW.setQlineD3(" TAS# ");								// l#10
			dQLW.setQlineD4(Integer.toString(tn)); 					// l#11  
			dQLW.setQlineD10("  TIME ");							// l#12
			dQLW.setQlineD11(ti);									// l#13
			writeTDQ (prw, Q, dQLW.getByteArray());  
			Abend998 (t, p, prw, Q, tn, caW, bQLW, dQLW, lRAW, chanOne, cont2);
			return; 
		}  
// ********* PUT ACCOUNT CODE BELOW HERE **************
		// Initialize the Account Request Area
		aRAW.setByteArray(ra);		   	   	 // Initialize request area wrapper
		aRAW.setCommand("REDKY");		   	 // Command
		aRAW.setTableName("ACC");          	 // Table name
		aRAW.setKeyName("SQ004");          	 // Key name
		aRAW.setKeyBid(caW.getBid());	     // Request Key BID
		aRAW.setKeyAid(caW.getAid());	   	 // Request Key Aid
		// write Account Request Area to container
		cont2.put(aRAW.getByteArray());					
		// Initialize The Account Work Area
		aWAW.setByteArray(awa); 						
		// write Account Work Area to container
		cont3.put(aWAW.getByteArray());					//ok ACC
		// Write Account Element List to container
		cont4.put(AccountElement);
// Bottom of the logic LINK to the "bridge" with the channel to get Account info
		p.link(chanOne);
		t.out.println("      got to LOCATION - 02  in account      "); 
		// Account request container read
		rspRequestCont = chanOne.getContainer(rqstCont);
		rspAccRequestData = rspRequestCont.get();
		// move the data to cData byte array in Account Request wrapper
		aRAW.setByteArray(rspAccRequestData);
		// read in Account Work container
		rspWorkCont = chanOne.getContainer(workCont);
		rspAccWorkData = rspWorkCont.get();
		// move the data to cData byte array in Account Work wrapper
		aWAW.setByteArray(rspAccWorkData);
				
		if ( !aRAW.getReturnCode().equals("  ") ){ 
			//prw.println("make sure the connection to MUF is established");
			// Move QLineC and write it to transient Q.
			for (int j = 0; j < 132; j++) {
				tdq[j] = (byte)0x40;}	 
			cQLW.setByteArray(tdq);									// l#1
			cQLW.setQlineC1(userIdBlock);							// l#2
			cQLW.setQlineC2(aWAW.getAccountId());					// l#3
			cQLW.setQlineC3(aWAW.getBranchId());					// l#4
			/*   This is packed                                        l#5 */
			cQLW.setQlineC4(String.valueOf(pd.getInt(aWAW.getAmtByteArray())));
			cQLW.setQlineC5(aWAW.getAddDate());						// l#6
			cQLW.setQlineC6(aWAW.getVerDate());						// l#7
			cQLW.setQlineC7(AccountElement);						// l#8
			writeTDQ (prw, Q, cQLW.getByteArray());        			
		    // Move QLineB and write it to TDQ.
			for (int j = 0; j < 132; j++) {
				tdq[j] = (byte)0x40;}	 
			bQLW.setByteArray(tdq);									// l#1
			bQLW.setQlineB1(aRAW.getCommand());						// l#2
			bQLW.setQlineB2(aRAW.getTableName());					// l#3
			bQLW.setQlineB3(aRAW.getKeyName());						// l#4
			bQLW.setQlineB4(aRAW.getReturnCode());					// l#5
			bQLW.setQlineB5(aRAW.getiReturnCode());					// l#6
					 
			byte [] arr = aRAW.getDbid().getBytes();				// DBID
			ByteBuffer bb = ByteBuffer.wrap(arr);
			ShortBuffer sb = bb.asShortBuffer();
			short s1 = sb.get();
			bQLW.setQlineB6(Short.toString(s1));  
					 
			arr = aRAW.getTblid().getBytes();						// TBLID
			bb = ByteBuffer.wrap(arr);
			sb = bb.asShortBuffer();
			s1 = sb.get();
			bQLW.setQlineB7(Short.toString(s1));  
					
			bQLW.setQlineB8(aRAW.getRecid());						// l#9
			bQLW.setQlineB9A(aRAW.getKeyBid());						// l#10
			bQLW.setQlineB9B(aRAW.getKeyAid());						// l#11
			writeTDQ (prw, Q, bQLW.getByteArray());  
		    // Move QLineD and write it to TDQ.
			for (int j = 0; j < 132; j++) {
				tdq[j] = (byte)0x40;}	 
			dQLW.setByteArray(tdq);									// l#1
			dQLW.setQlineD1("*** ERROR TRAN# ");					// L#2	
			dQLW.setQlineD2(caW.getTrancount());					// l#3
			dQLW.setQlineD5(" AID= ");								// l#4
			dQLW.setQlineD6(caW.getAid());							// l#5
			dQLW.setQlineD7(" ACC REDKY CODE= ");					// l#6
			dQLW.setQlineD8(aRAW.getReturnCode());					// l#7
			//int irc = Integer.parseInt(aRAW.getiReturnCode(), 16); 	// HEX byte to int 
			//dQLW.setQlineD9(Integer.toString(irc));					// Display irc
			byte b0 = aRAW.getiReturnCode().getBytes()[0];			// hexString TO hexByte
			s1 = (short)(0xff & b0);
			dQLW.setQlineD9(Short.toString(s1)); 					// l#8 
			dQLW.setQlineD3(" TAS# ");								// l#9
			dQLW.setQlineD4(Integer.toString(tn)); 					// l#10  
			dQLW.setQlineD10(" TIME ");								// l#11
			dQLW.setQlineD11(ti);									// l#12
			writeTDQ (prw, Q, dQLW.getByteArray());  		//ok
			Abend998 (t, p, prw, Q, tn, caW, bQLW, dQLW, lRAW, chanOne, cont2);
//  		GOTO 998-END
			return; 				// ok bottom of logic for ACC
		}
		t.out.println("      got to LOCATION - 03  in account      "); 
		for (int j = 0; j < 132; j++) {   //this format TESTED OK
			tdq[j] = (byte)0x40;}	 
		aQLW.setByteArray(tdq);									// l#1
		aQLW.setQlineA1("NXJU OK ");							// l#2
		aQLW.setQlineA2(caW.getDbid());							// l#3
		aQLW.setQlineA3(" TRAN# ");								// l#4
		aQLW.setQlineA4(caW.getTrancount());					// l#5
		aQLW.setQlineA5(" BID/AID= ");							// l#6
		aQLW.setQlineA6(caW.getBid());							// l#7
		aQLW.setQlineA7(caW.getAid());							// l#8
		aQLW.setQlineA8(" TEL ");								// l#9
		aQLW.setQlineA9(caW.getTid());							// l#8
		aQLW.setQlineA10(" NBAL=");								// l#11
		aQLW.setQlineA11(String.valueOf(pd.getInt(aWAW.getAmtByteArray())));
		aQLW.setQlineA12(" TAS#");								// l#13
		aQLW.setQlineA13(Integer.toString(tn));  				// l#14
		aQLW.setQlineA14(" TIME ");								// l#15
		aQLW.setQlineA15(ti);									// l#16
		writeTDQ (prw, Q, aQLW.getByteArray());			        // l#17
		return;  //This is 999-END.  does not need any more code or logic. 
// ********* PUT ACCOUNT CODE ABOVE HERE **************	
	}									
	 catch (ContainerErrorException e) {
 		t.err.println("No Response Container returned");
 	} catch (ChannelErrorException e) {
 		t.err.println("Channel error returned");
 	} catch (InvalidRequestException e) {
		// TODO Auto-generated catch block
		e.printStackTrace();
	} catch (CCSIDErrorException e) {
		// TODO Auto-generated catch block
		e.printStackTrace();
	} catch (CodePageErrorException e) {
		// TODO Auto-generated catch block
		e.printStackTrace();
	} catch (LengthErrorException e) {
		// TODO Auto-generated catch block
		e.printStackTrace();
	} catch (InvalidSystemIdException e) {
		// TODO Auto-generated catch block
		e.printStackTrace();
	} catch (NotAuthorisedException e) {
		// TODO Auto-generated catch block
		e.printStackTrace();
	} catch (InvalidProgramIdException e) {
		// TODO Auto-generated catch block
		e.printStackTrace();
	} catch (RolledBackException e) {
		// TODO Auto-generated catch block
		e.printStackTrace();
	} catch (TerminalException e) {
		// TODO Auto-generated catch block
		e.printStackTrace();
	}
	finally {
				// outWriter.println("Leaving writeTDQ()");
				//prw.println(" ");
			}	 
	 
	return;
	}

//  top of writeTDQ
//  top of writeTDQ
//  top of writeTDQ
	private static void writeTDQ (PrintWriter outWriter, TDQ Q, byte[] data)
	{
		byte[] tdqData;
		tdqData = data;
		outWriter.println("Entering writeTDQ()");
		try
		{
			Q.writeData(tdqData);			// write TDQ
		}
		catch(Throwable T)
			{
		   outWriter.print("TestOne: ");
		   outWriter.println("caught unexpected Throwable (" +
								   T.toString() +
								   ")");
			}
		finally
			{
		   outWriter.println("Leaving writeTDQ()");
			}
		return;
	}
	 
//  top of Abend998
//  top of Abend998
//  top of Abend998
	private static void Abend998 (Task t, Program p, PrintWriter prw, TDQ Q, int tn, CommareaWrapperU caW, BQlineWrapperU bQLW, DQlineWrapperU dQLW, RqstAreaWrapperU lRAW, Channel chanOne, Container cont2) {
	byte tdq[] = new byte [132];	
	// define Account request Area byte array		                            
	byte ra[] = new byte [256];							//ok
	for (int j = 0; j < 256; j++) {
		ra[j] = (byte)0x00;
	}
//	prw.println("      got to LOCATION - Abend998 - 01      "); 
	// Date and time formatting
	String ti;
	Calendar c = Calendar.getInstance();
//	prw.println("timezone default: " + c.getTimeZone());
//	DateFormat formatter1 = new SimpleDateFormat("hh:mm:ss:SSS a zzzz"); zone in characters
//	DateFormat formatter1 = new SimpleDateFormat("hh:mm:ss:SSS a Z");  zone in numbers
	DateFormat formatter1 = new SimpleDateFormat("HH:mm:ss:SSS");
	ti = formatter1.format(c.getTime());
	try {
	//prw.println("      got to LOCATION - Abend998 - 02      "); 
	// Initialize the Account Request Area
	lRAW.setByteArray(ra);		   	   	 // Initialize request area wrapper
	lRAW.setCommand("LOGTB");		   	 // Command
	lRAW.setTableName("   ");          	 // Table name
	lRAW.setKeyName("     ");          	 // Key name
// write Account Request Area to container 
	cont2.put(lRAW.getByteArray());				
	//prw.println("      got to LOCATION - Abend998 - 03      ");
	//prw.println("      got to LOCATION - Abend998 - 04      "); 
//Bottom of the logic LINK to the "bridge" with the channel to get Account info
	p.link(chanOne);
	//prw.println("      got to LOCATION - 01  in LOGTB      "); 
	// Account request container read
	Container rspRequestCont = chanOne.getContainer(rqstCont);
	byte[] rspAccRequestData = rspRequestCont.get();
// move the data to cData byte array in Account Request wrapper
	lRAW.setByteArray(rspAccRequestData);
// move the data to cData byte array in Account Request wrapper
	lRAW.setByteArray(rspAccRequestData);
	
	if ( !lRAW.getReturnCode().equals("  ") ){ 	
		//prw.println("make sure the connection to MUF is established");
// Move QLine and write it to transient Q.
		for (int j = 0; j < 132; j++) {
			tdq[j] = (byte)0x40;
		}	 
		bQLW.setByteArray(tdq);									// l#1
		bQLW.setBuffer(userIdBlock);
		writeTDQ (prw, Q, bQLW.getByteArray()); 
		
 // Move QLineB and write it to TDQ.
		for (int j = 0; j < 132; j++) {
			tdq[j] = (byte)0x40;
		}	 
		bQLW.setByteArray(tdq);									// l#1
		bQLW.setQlineB1(lRAW.getCommand());						// l#2
		bQLW.setQlineB2(lRAW.getTableName());					// l#3
		bQLW.setQlineB3(lRAW.getKeyName());						// l#4
		bQLW.setQlineB4(lRAW.getReturnCode());					// l#5
		bQLW.setQlineB5(lRAW.getiReturnCode());					// l#6
		 
		byte [] arr = lRAW.getDbid().getBytes();				// DBID
		ByteBuffer bb = ByteBuffer.wrap(arr);
		ShortBuffer sb = bb.asShortBuffer();
		short s1 = sb.get();
		bQLW.setQlineB6(Short.toString(s1));  
		 
		arr = lRAW.getTblid().getBytes();						// TBLID
		bb = ByteBuffer.wrap(arr);
		sb = bb.asShortBuffer();
		s1 = sb.get();
		bQLW.setQlineB7(Short.toString(s1));  
		
		bQLW.setQlineB8(lRAW.getRecid());						// l#9
		writeTDQ (prw, Q, bQLW.getByteArray());  
		 
  // Move the key and write it to TDQ.
		for (int j = 0; j < 132; j++) {
			tdq[j] = (byte)0x40;
		}	 
		bQLW.setBuffer(lRAW.getKeyValue());
		bQLW.setByteArray(tdq);									// l#1
		writeTDQ (prw, Q, bQLW.getByteArray());
		
  // Move QLineD and write it to TDQ.
		for (int j = 0; j < 132; j++) {
			tdq[j] = (byte)0x40;
		}	 
		dQLW.setByteArray(tdq);									// l#1
		dQLW.setQlineD1("ERR LOGTB TRAN#");						// L#2	
		dQLW.setQlineD2(caW.getTrancount());					// l#3
		dQLW.setQlineD5(" AID= ");								// l#4
		dQLW.setQlineD6(caW.getAid());							// l#5
		dQLW.setQlineD7(" LOGTB CODE=     ");					// l#6
		dQLW.setQlineD8(lRAW.getReturnCode());					// l#7
		//int irc = Integer.parseInt(lRAW.getiReturnCode(), 16); 	// HEX byte to int 
		//dQLW.setQlineD9(Integer.toString(irc));					// Display irc
		byte b0 = lRAW.getiReturnCode().getBytes()[0];			// hexString TO hexByte
		s1 = (short)(0xff & b0);
		dQLW.setQlineD9(Short.toString(s1)); 					// l#8 
		dQLW.setQlineD3(" TAS# ");								// l#9
		dQLW.setQlineD4(Integer.toString(tn)); 					// l#10  
		dQLW.setQlineD10(" TIME ");								// l#11
		dQLW.setQlineD11(ti);									// l#12
		writeTDQ (prw, Q, dQLW.getByteArray());  		
	//  bottom of logic for ACC
	}
	 return;     // this is the 999-END label equivalent 
	} 
	catch (ContainerErrorException e) {
			t.err.println("No Response Container returned");
		} catch (ChannelErrorException e) {
			t.err.println("Channel error returned");
		} catch (InvalidRequestException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (CCSIDErrorException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (CodePageErrorException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (LengthErrorException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (InvalidSystemIdException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (NotAuthorisedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (InvalidProgramIdException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (RolledBackException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (TerminalException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
 
	finally {}
	} 
	}
	
	
	
	







