package dbc.r15.sample.dccjcpr;
 

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.util.*;
import java.text.*;

import com.ibm.cics.server.CCSIDErrorException;
import com.ibm.cics.server.Channel;
import com.ibm.cics.server.ChannelErrorException;
import com.ibm.cics.server.CodePageErrorException;
import com.ibm.cics.server.Container;
import com.ibm.cics.server.ContainerErrorException;
import com.ibm.cics.server.InvalidProgramIdException;
import com.ibm.cics.server.InvalidRequestException;
import com.ibm.cics.server.InvalidSystemIdException;
import com.ibm.cics.server.LengthErrorException;
import com.ibm.cics.server.NotAuthorisedException;
import com.ibm.cics.server.Program;
import com.ibm.cics.server.RolledBackException;
import com.ibm.cics.server.Task;
import com.ibm.cics.server.TerminalException;
import com.ibm.cics.server.TerminalPrincipalFacility;

public class DCCJCPR {
		// report headers
	static String headingOne = "                    EMPLOYEES IN THE STATE OF TEXAS                         ";
	static String headingTwo = "CITY               NAME                            TOTAL COMP             TAXES ";
	
		// User Id Block container name.
	static final String userIdBlock	  = "DCCJCPR DB/CICS 15.0 SAMPLE";  
		// The five container names and the channel name
	static final String userIdCont      = "UsrInfoContainer";    // cont1     
	static final String rqstCont        = "RqstContainer   ";    // cont2     
	static final String workCont        = "WorkContainer   ";    // cont3     
	static final String elmtLstCont     = "ElmtLstContainer";    // cont4     
	static final String rqaCont         = "RQAContainer    ";    // cont5 (not used for RAAT)
	static final String testChannelName = "TestChannelBRAPR";    // chanOne	
	 
	public static void main(String[] args) {
		// instantiate the wrapper class for personnel and pay files
		RqstAreaWrapper pmfRAW = new RqstAreaWrapper();
		RqstAreaWrapper payRAW = new RqstAreaWrapper();
		PmfWorkAreaWrapper pmfWAW = new PmfWorkAreaWrapper();
		PayWorkAreaWrapper payWAW = new PayWorkAreaWrapper();
		PrintLineWrapper plw = new PrintLineWrapper();
		Container rspEmpWorkCont;
		Container rspPayWorkCont;
		byte[] rspEmpWorkData; 
		byte[] rspPayRequestData;
		byte[] rspPayWorkData;
		// define byte array for reserve area 1		                            
		byte b7[] = new byte [7];
		for (int j = 0; j < 7; j++) {
			b7[j] = (byte)0x00;
		};
		// Define byte array for reserve area 2
		byte b50 [] = new byte [50];
		for (int i = 0; i < 50; i++) {
			b50[i] = (byte)0x00;
		};
			 
		// define byte array for PMF WORK AREA 
		byte b76 [] = new byte [76]; 
		for (int i = 0; i < 76; i++) {
			b76[i] = (byte)0x00;
		};
		// define byte array for PAY WORK AREA 
		byte b40 [] = new byte [40];
		for (int i = 0; i < 40; i++) {
			b40[i] = (byte)0x00;
		};
		// define byte array for PRINT LINE 
		byte b80 [] = new byte [80];
		for (int i = 0; i < 80; i++) {
			b80[i] = (byte)0x40;
		}
		// Create an output data stream
		ByteArrayOutputStream baos = new ByteArrayOutputStream();
		BufferedOutputStream bos = new BufferedOutputStream(baos);
		DataOutputStream dos = new DataOutputStream(bos);
		  
		ByteArrayOutputStream baos1 = new ByteArrayOutputStream();
		BufferedOutputStream bos1 = new BufferedOutputStream(baos1);
		DataOutputStream dos1 = new DataOutputStream(bos1);
		
		// PMF Element List define
		PersonelElmentList pmfEl = new PersonelElmentList("ADEMP", " ", "     ");
		// PAY ELEMENT LIST define
		PayElmentList payEl = new PayElmentList("PYIDT", " ", "FIGSS", " ", "     ");
		//PAY RQST AREA define
		PayRqstArea payRq = new PayRqstArea ("REDKY", "PAY", "EMPNO", "  ", (byte)0x00, (short)0x0001, b7, " ",     
	                            b50, "00000");
		// get access to EIB     
        
		Task t = null;
		try {
			t = Task.getTask();
			if (t == null) {
				System.err.println("Program DCCJCPR: Can't get Task");
			} else {
				int pi = 0;
		//		t.out.println("Entering Program DCCJCPR.main()");
				dos1.write(headingOne.getBytes()); // heading line 1
				plw.setByteArray(b80);
				dos1.write(plw.getByteArray());    // blank line
				dos1.write(headingTwo.getBytes()); // heading line 2
				plw.setBuffer(" ");
				dos1.write(plw.getByteArray());    // blank line
				pi = 4;                  		   // up the index to 4 lines	
		//		Code Decimal formatting here
				NumberFormat nft = new DecimalFormat("###,###.00");   // tax format
				NumberFormat nfc = new DecimalFormat("#,###,###.00"); // compensation format
				double d = 0, dd = 0, dw = 0, dc = 0;
				double tt = 0, tc = 0;  // total tax, total compensation
// Create a Channel to pass to the "bridge" program
				Channel chanOne = t.createChannel(testChannelName);

// Create 4 Containers to hold the "User-Id","request area", "work area", "element list"  
				Container cont1 = chanOne.createContainer(userIdCont); 
				Container cont2 = chanOne.createContainer(rqstCont);
				Container cont3 = chanOne.createContainer(workCont);
				Container cont4 = chanOne.createContainer(elmtLstCont);
// User_ID block container write
				cont1.put(userIdBlock); 
				// t.out.println("Call the PersonelRqstArea constructor"); 
				
				// Create the request area and place it into the "request container"
				PersonelRqstArea pmfRq = new PersonelRqstArea ("LOCKY", "PMF", "STZIP", "  ", (byte)0x00, (short)0x0001, b7, " ",     
                                    b50, "TX", "00000");  
				 
// PMF RQST AREA container write
				//byte[] b1 = pmfRq.rqstCommand.getBytes();
				// Convert the String data to byte array and write them out to the stream 
				dos.write(pmfRq.rqstCommand.getBytes());				
				dos.write(pmfRq.fileName.getBytes()); 
				dos.write(pmfRq.keyName.getBytes());
				dos.write(pmfRq.returnCode.getBytes());
				// Data is already in byte array format, so just write it out to stream
				dos.write(pmfRq.recordId);
				// Data is in primitive type "short", so write it out to stream
				dos.writeShort(pmfRq.dataBaseId);
				dos.write(pmfRq.rsvOne);
				dos.write(pmfRq.actCode.getBytes());
				dos.write(pmfRq.rsvTwo);     
				dos.write(pmfRq.stateCode.getBytes());			
				dos.write(pmfRq.zipCode.getBytes());
// flush				 
				dos.flush(); 
				cont2.put(baos.toByteArray());
				// RESET the stream to make the index go back to 0	
				baos.reset();
 
				// Create the Program object to link to
				Program p = new Program();
				p.setName("DCBRAPR");

				// Now do the LINK passing the Channel
				// t.out.println("About to link to the bridge for the first time");
// LINK to the "bridge" (for the 1st time)
				p.link(chanOne);

				/*
				 *  Now read back in the container from the called programs.
				 *  Check the RC, move in the new command, write it back 
				 *  to the container
				 */
// PMF RQST container read
					Container rspRequestCont = chanOne.getContainer(rqstCont);
					byte[] rspPmfRequestData = rspRequestCont.get();
					// probably don't need the next sentence					
					// String responseString = new String(rspRequestData);
					 
					// move the data to cData byte array
					pmfRAW.setByteArray(rspPmfRequestData);
					
					if ( !pmfRAW.getReturnCode().equals("  ") ) {
						t.out.println("make sure the connection to MUF is established");
					    // and get out; otherwise continue with the rest of the process
						}
					if ( !pmfRAW.getActivityCode().equals("A")) {
						t.out.println("Activity code is NOT ok, value is : " + pmfRAW.getActivityCode());	
					}
					 
					// PMF RQST "REDLE" initialize command (one time; outside of loop) 
					pmfRAW.setCommand("REDLE");
					rspPmfRequestData = pmfRAW.getByteArray(); // re-initialize the array
// TOP OF MOST OUTER LOOP

					while ( pmfRAW.getReturnCode().equals("  ") && (pi < 22)) {  
						/* build the pay request area and write it out to the
						 * request container along with perhaps the work area 
						 * and link back again to the DCBRAPR program with a channel 
						 */
						while (pi < 22) {  
// TOP OF INNER LOOP

						
// PMF RQST AREA container write
					    cont2.put(pmfRAW.getByteArray());	// READ LOCATED RECORD ON PERSONNEL FILE
// PMF WORK AREA container write
						// initialize the WORK AREA wrapper array
						pmfWAW.setByteArray(b76);
						cont3.put(pmfWAW.getByteArray());
// PMF Element List container write
						//PersonelElmentList pmfEl = new PersonelElmentList("ADEMP", " ", "     ");
						dos.write(pmfEl.personelNumber.getBytes());
					    dos.write(pmfEl.securityCode.getBytes());
					    dos.write(pmfEl.endOfElmentList.getBytes());
					    dos.flush();
					    cont4.put(baos.toByteArray());
					    baos.reset();
// LINK to the "bridge" (for the 2nd time)
					    p.link(chanOne);
// PMF RQST AREA container read 
					    rspPmfRequestData = chanOne.getContainer(rqstCont).get();
					    pmfRAW.setByteArray(rspPmfRequestData);
// PMF WORK AREA container read 
					    rspEmpWorkCont = chanOne.getContainer(workCont);
					    // define rspEmpWorkData outside of the loop as a new byte array, then use it below in a loop   
					    rspEmpWorkData = rspEmpWorkCont.get(); // this can create lots of storage inside a loop
					    // instantiate the Employee work area wrapper class 
					    // initialize the wrapper array; get all the fields you need out of it 
					    pmfWAW.setByteArray(rspEmpWorkData);
					     
					    if ( pmfRAW.getReturnCode().equals("14") )
							t.out.println("go to shutdown label" + "                    ");
					    if ( !pmfRAW.getReturnCode().equals("  ") )
							t.out.println("go to ABEND label" + "                    ");
					    if ( !pmfWAW.getEmpState().equals("TX"))
					    	t.out.println("go to shutdown label");
					    
		//				t.out.println("Employee number : " + pmfWAW.getEmpNumber() + "                    ");
		//				t.out.println("Employee name : " + pmfWAW.getEmpName() + "                    ");
		//				t.out.println("Employee address : " + pmfWAW.getEmpAddress() + "                    ");
		//				t.out.println("Employee city : " + pmfWAW.getEmpCity() + "                    ");
		//				t.out.println("Employee state : " + pmfWAW.getEmpState() + "                    ");
		//				t.out.println("Employee zip : " + pmfWAW.getEmpZip() + "                    ");
						// here set "REDNX" to PMFCMD in the request area; this is for the next round and not this round.
						// set PMFEMPNO from work area just obtained to PAYKEYVL on the PAY RQST area
						// Create the request area and place it into the "request container"
// PAY RQST AREA container write
						/*PayRqstArea payRq = new PayRqstArea ("REDKY", "PAY", "EMPNO", "  ", (byte)0x00, (short)0x0001, b7, " ",     
		                                    b50, "00000"); */
						// Convert the String data to byte array and write them out to the stream 
						dos.write(payRq.rqstCommand.getBytes());						
						dos.write(payRq.fileName.getBytes()); 
						dos.write(payRq.keyName.getBytes());
						dos.write(payRq.returnCode.getBytes());
						// Data is already in byte array format, so just write it out to stream
						dos.write(payRq.recordId);
						// Data is in primitive type "short", so write it out to stream
						dos.writeShort(payRq.dataBaseId);		
						dos.write(payRq.rsvOne);
						dos.write(payRq.actCode.getBytes());
						dos.write(payRq.rsvTwo);     		
						dos.write(payRq.keyValue.getBytes());
						dos.flush();
						 
						// initialize the pay request wrapper
						payRAW.setByteArray(baos.toByteArray());
						// set the key value with the employee number just got						
						payRAW.setKeyValue(pmfWAW.getEmpNumber());
						// write it out to the pay request container
						cont2.put(payRAW.getByteArray());
						// RESET the stream to make the index go back to 0	
						baos.reset();
// PAY WORK AREA container write
						// initialize the pay wrapper array
						payWAW.setByteArray(b40);
						cont3.put(payWAW.getByteArray());
// PAY ELEMENT LIST container write
						// PayElmentList payEl = new PayElmentList("PYIDT", " ", "FIGSS", " ", "     ");
						dos.write(payEl.payIdentifierName.getBytes());
						dos.write(payEl.secCodePayId1.getBytes());
						dos.write(payEl.figIdentifier.getBytes());
						dos.write(payEl.secCodePayId2.getBytes());
						dos.write(payEl.endOfList.getBytes());
						dos.flush();
					    cont4.put(baos.toByteArray());
					    baos.reset();
// LINK to the "bridge" (for 3rd time)
					    
					    p.link(chanOne);
// PAY RQST AREA container read 
					    // Used  the same object of rspRequestData as recipient of the PMF RQST container
					    rspPayRequestData = chanOne.getContainer(rqstCont).get();
					    payRAW.setByteArray(rspPayRequestData);
// PAY WORK AREA container read 
					    rspPayWorkCont = chanOne.getContainer(workCont);   
					    rspPayWorkData = rspPayWorkCont.get(); // this can create lots of storage inside a loop
					    // initialize the Employee work area wrapper class 
					    payWAW.setByteArray(rspPayWorkData);
					     
					    if ( payRAW.getReturnCode().equals("14") )
							t.out.println("PAY RC = 14, go to shutdown label");
					    if ( !payRAW.getReturnCode().equals("  ") )
							t.out.println("PAY RC NOT = SPACES, go to ABEND label");
					    if ( payWAW.getPayActivity().equals("A")) {
				
// build the print line to be displayed on the screen
						plw.setCity(pmfWAW.getEmpCity());
						plw.setName(pmfWAW.getEmpName());
						//plw.setPay(payWAW.getPaySalary());
						dc = Double.valueOf(payWAW.getPayCommission());
						dw = Double.valueOf(payWAW.getPayWages());
						d = dc + dw;
						dd = d / (int) 100;
						tc += dd;
						plw.setPay(nfc.format(dd));
						//plw.setTaxes(payWAW.getPayTaxes());
						d = Double.valueOf(payWAW.getPayTaxes());
						dd = d / (int) 100;
						tt += dd;
						plw.setTaxes(nft.format(dd));
						dos1.write(plw.getByteArray());
						pi++;
					    }
						// restore the PMF request values
						pmfRAW.setByteArray(rspPmfRequestData);
						// PMF RQST "REDNX" initialize command (one time; outside of loop) 
						pmfRAW.setCommand("REDNX");
						rspPmfRequestData = pmfRAW.getByteArray(); //re-initialize PMF request area
						}
// BOTTOM OF THE MOST INNER LOOP

						plw.setBuffer(" ");			 // print a blank line
						dos1.write(plw.getByteArray());
						plw.setPay(nfc.format(tc));  // total compensation
						plw.setTaxes(nft.format(tt));// total tax
						plw.setCity("TOTALS");
						plw.setName("                        ");
						dos1.write(plw.getByteArray());
						
						dos1.flush();
						plw.setByteArray(baos1.toByteArray());
						t.out.println(plw.getBuffer()); // Display the full screen
						baos1.reset();		 
						}
// BOTTOM OF MOST OUTER LOOP
					  
					if ( !pmfRAW.getReturnCode().equals("  ") ) {
						t.out.println("Return Code : " + pmfRAW.getReturnCode());
					}
			
					}
				}
				 catch (ContainerErrorException e) {
    				t.err.println("No Response Container returned");
    			} catch (ChannelErrorException e) {
    				t.err.println("Channel error returned");
    			} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (InvalidRequestException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (CCSIDErrorException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (CodePageErrorException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (LengthErrorException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (InvalidSystemIdException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (NotAuthorisedException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (InvalidProgramIdException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (RolledBackException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (TerminalException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
	
				finally 
				// {t.out.println("Leaving DCCJCPR.main()" + "                    ");}
				{t.out.println(" ");}
	}			
}
	
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		

		
